"""
Generated by Statechart compiler by Glenn De Jonghe, Joeri Exelmans, Simon Van Mierlo, and Yentl Van Tendeloo (for the inspiration)

Date:   Fri Nov 10 08:54:09 2017

Model author: Yentl Van Tendeloo
Model name:   MvK Server
Model description:
Modelverse Kernel client.
"""

from sccd.runtime.statecharts_core import *
import sccd.runtime.accurate_time as accurate_time
import time
import os
import sys
import uuid
import urllib
import json
import sys

# package "MvK Server"

class Modelverse(RuntimeClassBase):
    def __init__(self, controller):
        RuntimeClassBase.__init__(self, controller)
        
        self.semantics.big_step_maximality = StatechartSemantics.TakeMany
        self.semantics.internal_event_lifeline = StatechartSemantics.Queue
        self.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep
        self.semantics.priority = StatechartSemantics.SourceChild
        self.semantics.concurrency = StatechartSemantics.Single
        
        # build Statechart structure
        self.build_statechart_structure()
        
        # call user defined constructor
        Modelverse.user_defined_constructor(self)
    
    def user_defined_constructor(self):
        self.controller.taskname = None
        self.actions = {None: []}
        self.responses = []
        self.http_clients = []
        self.context = None
        self.registered_metamodel = {}
        self.inputs = {}
        self.finish_output_thread = False
    
    def user_defined_destructor(self):
        pass
    
    
    # user defined method
    def load_action(self, context):
        action = self.actions[context].pop(0)
        self.parameters = action["parameters"]
        self.current_ID = action["ID"]
    
    
    # user defined method
    def dict_to_list(self, d):
        l = []
        for k, v in d.iteritems():
            l.append(k)
            l.append(v)
        l.append("")
        return l
    
    
    # user defined method
    def split_response(self, response):
        splitted = response.strip().split(": ", 1)
        if len(splitted) > 1:
            return splitted[1].split("\n")
        else:
            return []
    
    
    # user defined method
    def expect_response(self, expected, pop = None):
        if pop == None: pop = True
        if self.responses and self.responses[0] == expected:
            if pop:
                del self.responses[0]
            return True
        else:
            return False
    
    
    # user defined method
    def expect_response_partial(self, expected, pop = None):
        if pop == None: pop = False
        if self.responses and self.responses[0].startswith(expected):
            if pop:
                del self.responses[0]
            return True
        else:
            return False
    
    
    # user defined method
    def expect_action(self, context, expected):
        if isinstance(expected, list):
            return self.actions[context] and self.actions[context][0]["name"] in expected
        else:
            return self.actions[context] and self.actions[context][0]["name"] == expected
    
    
    # user defined method
    def expect_input(self, context, expected):
        if isinstance(expected, list):
            return self.inputs[context] and self.inputs[context][0]["name"] in expected
        else:
            return self.inputs[context] and self.inputs[context][0]["name"] == expected
    
    
    # builds Statechart structure
    def build_statechart_structure(self):
        
        # state <root>
        self.states[""] = State(0, "", self)
        
        # state /init
        self.states["/init"] = State(1, "/init", self)
        self.states["/init"].setEnter(self._init_enter)
        
        # state /waiting
        self.states["/waiting"] = State(2, "/waiting", self)
        
        # state /initialized
        self.states["/initialized"] = ParallelState(3, "/initialized", self)
        self.states["/initialized"].setEnter(self._initialized_enter)
        
        # state /initialized/http_mapper
        self.states["/initialized/http_mapper"] = State(4, "/initialized/http_mapper", self)
        
        # state /initialized/http_mapper/init
        self.states["/initialized/http_mapper/init"] = State(5, "/initialized/http_mapper/init", self)
        
        # state /initialized/http_mapper/finished
        self.states["/initialized/http_mapper/finished"] = State(6, "/initialized/http_mapper/finished", self)
        
        # state /initialized/behaviour
        self.states["/initialized/behaviour"] = State(7, "/initialized/behaviour", self)
        
        # state /initialized/behaviour/init
        self.states["/initialized/behaviour/init"] = State(8, "/initialized/behaviour/init", self)
        self.states["/initialized/behaviour/init"].setEnter(self._initialized_behaviour_init_enter)
        
        # state /initialized/behaviour/init/connect_http_client
        self.states["/initialized/behaviour/init/connect_http_client"] = State(9, "/initialized/behaviour/init/connect_http_client", self)
        
        # state /initialized/behaviour/init/waiting_http_client
        self.states["/initialized/behaviour/init/waiting_http_client"] = State(10, "/initialized/behaviour/init/waiting_http_client", self)
        
        # state /initialized/behaviour/init/wait_for_taskname_ack
        self.states["/initialized/behaviour/init/wait_for_taskname_ack"] = State(11, "/initialized/behaviour/init/wait_for_taskname_ack", self)
        
        # state /initialized/behaviour/operations
        self.states["/initialized/behaviour/operations"] = State(12, "/initialized/behaviour/operations", self)
        
        # state /initialized/behaviour/operations/history
        self.states["/initialized/behaviour/operations/history"] = DeepHistoryState(13, "/initialized/behaviour/operations/history", self)
        
        # state /initialized/behaviour/operations/login
        self.states["/initialized/behaviour/operations/login"] = State(14, "/initialized/behaviour/operations/login", self)
        
        # state /initialized/behaviour/operations/login/wait_prompt_1
        self.states["/initialized/behaviour/operations/login/wait_prompt_1"] = State(15, "/initialized/behaviour/operations/login/wait_prompt_1", self)
        
        # state /initialized/behaviour/operations/login/wait_prompt_2
        self.states["/initialized/behaviour/operations/login/wait_prompt_2"] = State(16, "/initialized/behaviour/operations/login/wait_prompt_2", self)
        
        # state /initialized/behaviour/operations/login/wait_prompt_existing
        self.states["/initialized/behaviour/operations/login/wait_prompt_existing"] = State(17, "/initialized/behaviour/operations/login/wait_prompt_existing", self)
        
        # state /initialized/behaviour/operations/login/login_ok
        self.states["/initialized/behaviour/operations/login/login_ok"] = State(18, "/initialized/behaviour/operations/login/login_ok", self)
        
        # state /initialized/behaviour/operations/model_list
        self.states["/initialized/behaviour/operations/model_list"] = State(19, "/initialized/behaviour/operations/model_list", self)
        self.states["/initialized/behaviour/operations/model_list"].setEnter(self._initialized_behaviour_operations_model_list_enter)
        
        # state /initialized/behaviour/operations/model_add
        self.states["/initialized/behaviour/operations/model_add"] = State(20, "/initialized/behaviour/operations/model_add", self)
        
        # state /initialized/behaviour/operations/model_add/send_metadata
        self.states["/initialized/behaviour/operations/model_add/send_metadata"] = State(21, "/initialized/behaviour/operations/model_add/send_metadata", self)
        self.states["/initialized/behaviour/operations/model_add/send_metadata"].setEnter(self._initialized_behaviour_operations_model_add_send_metadata_enter)
        
        # state /initialized/behaviour/operations/model_delete
        self.states["/initialized/behaviour/operations/model_delete"] = State(22, "/initialized/behaviour/operations/model_delete", self)
        self.states["/initialized/behaviour/operations/model_delete"].setEnter(self._initialized_behaviour_operations_model_delete_enter)
        
        # state /initialized/behaviour/operations/model_list_full
        self.states["/initialized/behaviour/operations/model_list_full"] = State(23, "/initialized/behaviour/operations/model_list_full", self)
        self.states["/initialized/behaviour/operations/model_list_full"].setEnter(self._initialized_behaviour_operations_model_list_full_enter)
        
        # state /initialized/behaviour/operations/verify
        self.states["/initialized/behaviour/operations/verify"] = State(24, "/initialized/behaviour/operations/verify", self)
        self.states["/initialized/behaviour/operations/verify"].setEnter(self._initialized_behaviour_operations_verify_enter)
        
        # state /initialized/behaviour/operations/verify/waiting
        self.states["/initialized/behaviour/operations/verify/waiting"] = State(25, "/initialized/behaviour/operations/verify/waiting", self)
        
        # state /initialized/behaviour/operations/alter_context
        self.states["/initialized/behaviour/operations/alter_context"] = State(26, "/initialized/behaviour/operations/alter_context", self)
        
        # state /initialized/behaviour/operations/model_upload
        self.states["/initialized/behaviour/operations/model_upload"] = State(27, "/initialized/behaviour/operations/model_upload", self)
        
        # state /initialized/behaviour/operations/model_upload/send_metadata
        self.states["/initialized/behaviour/operations/model_upload/send_metadata"] = State(28, "/initialized/behaviour/operations/model_upload/send_metadata", self)
        self.states["/initialized/behaviour/operations/model_upload/send_metadata"].setEnter(self._initialized_behaviour_operations_model_upload_send_metadata_enter)
        
        # state /initialized/behaviour/operations/model_upload/send_model
        self.states["/initialized/behaviour/operations/model_upload/send_model"] = State(29, "/initialized/behaviour/operations/model_upload/send_model", self)
        self.states["/initialized/behaviour/operations/model_upload/send_model"].setEnter(self._initialized_behaviour_operations_model_upload_send_model_enter)
        
        # state /initialized/behaviour/operations/model_overwrite
        self.states["/initialized/behaviour/operations/model_overwrite"] = State(30, "/initialized/behaviour/operations/model_overwrite", self)
        
        # state /initialized/behaviour/operations/model_overwrite/send_metadata
        self.states["/initialized/behaviour/operations/model_overwrite/send_metadata"] = State(31, "/initialized/behaviour/operations/model_overwrite/send_metadata", self)
        self.states["/initialized/behaviour/operations/model_overwrite/send_metadata"].setEnter(self._initialized_behaviour_operations_model_overwrite_send_metadata_enter)
        
        # state /initialized/behaviour/operations/model_overwrite/send_model
        self.states["/initialized/behaviour/operations/model_overwrite/send_model"] = State(32, "/initialized/behaviour/operations/model_overwrite/send_model", self)
        self.states["/initialized/behaviour/operations/model_overwrite/send_model"].setEnter(self._initialized_behaviour_operations_model_overwrite_send_model_enter)
        
        # state /initialized/behaviour/operations/disconnect
        self.states["/initialized/behaviour/operations/disconnect"] = State(33, "/initialized/behaviour/operations/disconnect", self)
        self.states["/initialized/behaviour/operations/disconnect"].setEnter(self._initialized_behaviour_operations_disconnect_enter)
        
        # state /initialized/behaviour/operations/user_logout
        self.states["/initialized/behaviour/operations/user_logout"] = State(34, "/initialized/behaviour/operations/user_logout", self)
        self.states["/initialized/behaviour/operations/user_logout"].setEnter(self._initialized_behaviour_operations_user_logout_enter)
        
        # state /initialized/behaviour/operations/user_delete
        self.states["/initialized/behaviour/operations/user_delete"] = State(35, "/initialized/behaviour/operations/user_delete", self)
        self.states["/initialized/behaviour/operations/user_delete"].setEnter(self._initialized_behaviour_operations_user_delete_enter)
        
        # state /initialized/behaviour/operations/model_render
        self.states["/initialized/behaviour/operations/model_render"] = State(36, "/initialized/behaviour/operations/model_render", self)
        self.states["/initialized/behaviour/operations/model_render"].setEnter(self._initialized_behaviour_operations_model_render_enter)
        
        # state /initialized/behaviour/operations/model_rendered
        self.states["/initialized/behaviour/operations/model_rendered"] = State(37, "/initialized/behaviour/operations/model_rendered", self)
        self.states["/initialized/behaviour/operations/model_rendered"].setEnter(self._initialized_behaviour_operations_model_rendered_enter)
        
        # state /initialized/behaviour/operations/transformation_between
        self.states["/initialized/behaviour/operations/transformation_between"] = State(38, "/initialized/behaviour/operations/transformation_between", self)
        self.states["/initialized/behaviour/operations/transformation_between"].setEnter(self._initialized_behaviour_operations_transformation_between_enter)
        
        # state /initialized/behaviour/operations/transformation_signature
        self.states["/initialized/behaviour/operations/transformation_signature"] = State(39, "/initialized/behaviour/operations/transformation_signature", self)
        self.states["/initialized/behaviour/operations/transformation_signature"].setEnter(self._initialized_behaviour_operations_transformation_signature_enter)
        
        # state /initialized/behaviour/operations/process_signature
        self.states["/initialized/behaviour/operations/process_signature"] = State(40, "/initialized/behaviour/operations/process_signature", self)
        self.states["/initialized/behaviour/operations/process_signature"].setEnter(self._initialized_behaviour_operations_process_signature_enter)
        
        # state /initialized/behaviour/operations/store_on_scripted
        self.states["/initialized/behaviour/operations/store_on_scripted"] = State(41, "/initialized/behaviour/operations/store_on_scripted", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_MT
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"] = State(42, "/initialized/behaviour/operations/store_on_scripted/transformation_add_MT", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata"] = State(43, "/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata", self)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata"].setEnter(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_enter)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel"] = State(44, "/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model"] = State(45, "/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model", self)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model"].setEnter(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_enter)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_AL
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"] = State(46, "/initialized/behaviour/operations/store_on_scripted/transformation_add_AL", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata"] = State(47, "/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata", self)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata"].setEnter(self._initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_enter)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_AL/edit_metamodel
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/edit_metamodel"] = State(48, "/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/edit_metamodel", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model"] = State(49, "/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model", self)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model"].setEnter(self._initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_enter)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL"] = State(50, "/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata"] = State(51, "/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata", self)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata"].setEnter(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_enter)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel"] = State(52, "/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_execute
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute"] = State(53, "/initialized/behaviour/operations/store_on_scripted/transformation_execute", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation"] = State(54, "/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation", self)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation"].setEnter(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_enter)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"] = State(55, "/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"] = State(56, "/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/process_execute
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute"] = State(57, "/initialized/behaviour/operations/store_on_scripted/process_execute", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/process_execute/init
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/init"] = State(58, "/initialized/behaviour/operations/store_on_scripted/process_execute/init", self)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/init"].setEnter(self._initialized_behaviour_operations_store_on_scripted_process_execute_init_enter)
        
        # state /initialized/behaviour/operations/store_on_scripted/process_execute/executing
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"] = State(59, "/initialized/behaviour/operations/store_on_scripted/process_execute/executing", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/process_execute/enacting
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"] = State(60, "/initialized/behaviour/operations/store_on_scripted/process_execute/enacting", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc"] = State(61, "/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/init
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/init"] = State(62, "/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/init", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"] = State(63, "/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"] = State(64, "/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op", self)
        
        # state /initialized/behaviour/operations/store_on_scripted/history
        self.states["/initialized/behaviour/operations/store_on_scripted/history"] = DeepHistoryState(65, "/initialized/behaviour/operations/store_on_scripted/history", self)
        
        # state /initialized/behaviour/operations/permission_modify
        self.states["/initialized/behaviour/operations/permission_modify"] = State(66, "/initialized/behaviour/operations/permission_modify", self)
        self.states["/initialized/behaviour/operations/permission_modify"].setEnter(self._initialized_behaviour_operations_permission_modify_enter)
        
        # state /initialized/behaviour/operations/permission_owner
        self.states["/initialized/behaviour/operations/permission_owner"] = State(67, "/initialized/behaviour/operations/permission_owner", self)
        self.states["/initialized/behaviour/operations/permission_owner"].setEnter(self._initialized_behaviour_operations_permission_owner_enter)
        
        # state /initialized/behaviour/operations/permission_group
        self.states["/initialized/behaviour/operations/permission_group"] = State(68, "/initialized/behaviour/operations/permission_group", self)
        self.states["/initialized/behaviour/operations/permission_group"].setEnter(self._initialized_behaviour_operations_permission_group_enter)
        
        # state /initialized/behaviour/operations/group_create
        self.states["/initialized/behaviour/operations/group_create"] = State(69, "/initialized/behaviour/operations/group_create", self)
        self.states["/initialized/behaviour/operations/group_create"].setEnter(self._initialized_behaviour_operations_group_create_enter)
        
        # state /initialized/behaviour/operations/group_delete
        self.states["/initialized/behaviour/operations/group_delete"] = State(70, "/initialized/behaviour/operations/group_delete", self)
        self.states["/initialized/behaviour/operations/group_delete"].setEnter(self._initialized_behaviour_operations_group_delete_enter)
        
        # state /initialized/behaviour/operations/group_owner_add
        self.states["/initialized/behaviour/operations/group_owner_add"] = State(71, "/initialized/behaviour/operations/group_owner_add", self)
        self.states["/initialized/behaviour/operations/group_owner_add"].setEnter(self._initialized_behaviour_operations_group_owner_add_enter)
        
        # state /initialized/behaviour/operations/group_owner_delete
        self.states["/initialized/behaviour/operations/group_owner_delete"] = State(72, "/initialized/behaviour/operations/group_owner_delete", self)
        self.states["/initialized/behaviour/operations/group_owner_delete"].setEnter(self._initialized_behaviour_operations_group_owner_delete_enter)
        
        # state /initialized/behaviour/operations/group_join
        self.states["/initialized/behaviour/operations/group_join"] = State(73, "/initialized/behaviour/operations/group_join", self)
        self.states["/initialized/behaviour/operations/group_join"].setEnter(self._initialized_behaviour_operations_group_join_enter)
        
        # state /initialized/behaviour/operations/group_kick
        self.states["/initialized/behaviour/operations/group_kick"] = State(74, "/initialized/behaviour/operations/group_kick", self)
        self.states["/initialized/behaviour/operations/group_kick"].setEnter(self._initialized_behaviour_operations_group_kick_enter)
        
        # state /initialized/behaviour/operations/group_list
        self.states["/initialized/behaviour/operations/group_list"] = State(75, "/initialized/behaviour/operations/group_list", self)
        self.states["/initialized/behaviour/operations/group_list"].setEnter(self._initialized_behaviour_operations_group_list_enter)
        
        # state /initialized/behaviour/operations/admin_promote
        self.states["/initialized/behaviour/operations/admin_promote"] = State(76, "/initialized/behaviour/operations/admin_promote", self)
        self.states["/initialized/behaviour/operations/admin_promote"].setEnter(self._initialized_behaviour_operations_admin_promote_enter)
        
        # state /initialized/behaviour/operations/admin_demote
        self.states["/initialized/behaviour/operations/admin_demote"] = State(77, "/initialized/behaviour/operations/admin_demote", self)
        self.states["/initialized/behaviour/operations/admin_demote"].setEnter(self._initialized_behaviour_operations_admin_demote_enter)
        
        # state /initialized/behaviour/operations/conformance_delete
        self.states["/initialized/behaviour/operations/conformance_delete"] = State(78, "/initialized/behaviour/operations/conformance_delete", self)
        self.states["/initialized/behaviour/operations/conformance_delete"].setEnter(self._initialized_behaviour_operations_conformance_delete_enter)
        
        # state /initialized/behaviour/operations/conformance_add
        self.states["/initialized/behaviour/operations/conformance_add"] = State(79, "/initialized/behaviour/operations/conformance_add", self)
        self.states["/initialized/behaviour/operations/conformance_add"].setEnter(self._initialized_behaviour_operations_conformance_add_enter)
        
        # state /initialized/behaviour/operations/folder_create
        self.states["/initialized/behaviour/operations/folder_create"] = State(80, "/initialized/behaviour/operations/folder_create", self)
        self.states["/initialized/behaviour/operations/folder_create"].setEnter(self._initialized_behaviour_operations_folder_create_enter)
        
        # state /initialized/behaviour/operations/model_types
        self.states["/initialized/behaviour/operations/model_types"] = State(81, "/initialized/behaviour/operations/model_types", self)
        self.states["/initialized/behaviour/operations/model_types"].setEnter(self._initialized_behaviour_operations_model_types_enter)
        
        # state /initialized/behaviour/operations/element_list
        self.states["/initialized/behaviour/operations/element_list"] = State(82, "/initialized/behaviour/operations/element_list", self)
        self.states["/initialized/behaviour/operations/element_list"].setEnter(self._initialized_behaviour_operations_element_list_enter)
        
        # state /initialized/behaviour/operations/element_list_nice
        self.states["/initialized/behaviour/operations/element_list_nice"] = State(83, "/initialized/behaviour/operations/element_list_nice", self)
        self.states["/initialized/behaviour/operations/element_list_nice"].setEnter(self._initialized_behaviour_operations_element_list_nice_enter)
        
        # state /initialized/behaviour/operations/types
        self.states["/initialized/behaviour/operations/types"] = State(84, "/initialized/behaviour/operations/types", self)
        self.states["/initialized/behaviour/operations/types"].setEnter(self._initialized_behaviour_operations_types_enter)
        
        # state /initialized/behaviour/operations/types_full
        self.states["/initialized/behaviour/operations/types_full"] = State(85, "/initialized/behaviour/operations/types_full", self)
        self.states["/initialized/behaviour/operations/types_full"].setEnter(self._initialized_behaviour_operations_types_full_enter)
        
        # state /initialized/behaviour/operations/read_info
        self.states["/initialized/behaviour/operations/read_info"] = State(86, "/initialized/behaviour/operations/read_info", self)
        self.states["/initialized/behaviour/operations/read_info"].setEnter(self._initialized_behaviour_operations_read_info_enter)
        
        # state /initialized/behaviour/operations/read_attrs
        self.states["/initialized/behaviour/operations/read_attrs"] = State(87, "/initialized/behaviour/operations/read_attrs", self)
        self.states["/initialized/behaviour/operations/read_attrs"].setEnter(self._initialized_behaviour_operations_read_attrs_enter)
        
        # state /initialized/behaviour/operations/read_defined_attrs
        self.states["/initialized/behaviour/operations/read_defined_attrs"] = State(88, "/initialized/behaviour/operations/read_defined_attrs", self)
        self.states["/initialized/behaviour/operations/read_defined_attrs"].setEnter(self._initialized_behaviour_operations_read_defined_attrs_enter)
        
        # state /initialized/behaviour/operations/instantiate
        self.states["/initialized/behaviour/operations/instantiate"] = State(89, "/initialized/behaviour/operations/instantiate", self)
        
        # state /initialized/behaviour/operations/instantiate/decide_node_or_edge
        self.states["/initialized/behaviour/operations/instantiate/decide_node_or_edge"] = State(90, "/initialized/behaviour/operations/instantiate/decide_node_or_edge", self)
        
        # state /initialized/behaviour/operations/instantiate/created
        self.states["/initialized/behaviour/operations/instantiate/created"] = State(91, "/initialized/behaviour/operations/instantiate/created", self)
        
        # state /initialized/behaviour/operations/delete_element
        self.states["/initialized/behaviour/operations/delete_element"] = State(92, "/initialized/behaviour/operations/delete_element", self)
        self.states["/initialized/behaviour/operations/delete_element"].setEnter(self._initialized_behaviour_operations_delete_element_enter)
        
        # state /initialized/behaviour/operations/attr_assign
        self.states["/initialized/behaviour/operations/attr_assign"] = State(93, "/initialized/behaviour/operations/attr_assign", self)
        self.states["/initialized/behaviour/operations/attr_assign"].setEnter(self._initialized_behaviour_operations_attr_assign_enter)
        
        # state /initialized/behaviour/operations/attr_assign_code
        self.states["/initialized/behaviour/operations/attr_assign_code"] = State(94, "/initialized/behaviour/operations/attr_assign_code", self)
        self.states["/initialized/behaviour/operations/attr_assign_code"].setEnter(self._initialized_behaviour_operations_attr_assign_code_enter)
        
        # state /initialized/behaviour/operations/attr_delete
        self.states["/initialized/behaviour/operations/attr_delete"] = State(95, "/initialized/behaviour/operations/attr_delete", self)
        self.states["/initialized/behaviour/operations/attr_delete"].setEnter(self._initialized_behaviour_operations_attr_delete_enter)
        
        # state /initialized/behaviour/operations/attr_type
        self.states["/initialized/behaviour/operations/attr_type"] = State(96, "/initialized/behaviour/operations/attr_type", self)
        self.states["/initialized/behaviour/operations/attr_type"].setEnter(self._initialized_behaviour_operations_attr_type_enter)
        
        # state /initialized/behaviour/operations/attr_name
        self.states["/initialized/behaviour/operations/attr_name"] = State(97, "/initialized/behaviour/operations/attr_name", self)
        self.states["/initialized/behaviour/operations/attr_name"].setEnter(self._initialized_behaviour_operations_attr_name_enter)
        
        # state /initialized/behaviour/operations/attr_optional
        self.states["/initialized/behaviour/operations/attr_optional"] = State(98, "/initialized/behaviour/operations/attr_optional", self)
        self.states["/initialized/behaviour/operations/attr_optional"].setEnter(self._initialized_behaviour_operations_attr_optional_enter)
        
        # state /initialized/behaviour/operations/read_outgoing
        self.states["/initialized/behaviour/operations/read_outgoing"] = State(99, "/initialized/behaviour/operations/read_outgoing", self)
        self.states["/initialized/behaviour/operations/read_outgoing"].setEnter(self._initialized_behaviour_operations_read_outgoing_enter)
        
        # state /initialized/behaviour/operations/read_incoming
        self.states["/initialized/behaviour/operations/read_incoming"] = State(100, "/initialized/behaviour/operations/read_incoming", self)
        self.states["/initialized/behaviour/operations/read_incoming"].setEnter(self._initialized_behaviour_operations_read_incoming_enter)
        
        # state /initialized/behaviour/operations/read_association_source
        self.states["/initialized/behaviour/operations/read_association_source"] = State(101, "/initialized/behaviour/operations/read_association_source", self)
        self.states["/initialized/behaviour/operations/read_association_source"].setEnter(self._initialized_behaviour_operations_read_association_source_enter)
        
        # state /initialized/behaviour/operations/read_association_destination
        self.states["/initialized/behaviour/operations/read_association_destination"] = State(102, "/initialized/behaviour/operations/read_association_destination", self)
        self.states["/initialized/behaviour/operations/read_association_destination"].setEnter(self._initialized_behaviour_operations_read_association_destination_enter)
        
        # state /initialized/behaviour/operations/connections_between
        self.states["/initialized/behaviour/operations/connections_between"] = State(103, "/initialized/behaviour/operations/connections_between", self)
        self.states["/initialized/behaviour/operations/connections_between"].setEnter(self._initialized_behaviour_operations_connections_between_enter)
        
        # state /initialized/behaviour/operations/define_attribute
        self.states["/initialized/behaviour/operations/define_attribute"] = State(104, "/initialized/behaviour/operations/define_attribute", self)
        self.states["/initialized/behaviour/operations/define_attribute"].setEnter(self._initialized_behaviour_operations_define_attribute_enter)
        
        # state /initialized/behaviour/operations/undefine_attribute
        self.states["/initialized/behaviour/operations/undefine_attribute"] = State(105, "/initialized/behaviour/operations/undefine_attribute", self)
        self.states["/initialized/behaviour/operations/undefine_attribute"].setEnter(self._initialized_behaviour_operations_undefine_attribute_enter)
        
        # state /initialized/behaviour/operations/all_instances
        self.states["/initialized/behaviour/operations/all_instances"] = State(106, "/initialized/behaviour/operations/all_instances", self)
        self.states["/initialized/behaviour/operations/all_instances"].setEnter(self._initialized_behaviour_operations_all_instances_enter)
        
        # state /initialized/behaviour/operations/save
        self.states["/initialized/behaviour/operations/save"] = State(107, "/initialized/behaviour/operations/save", self)
        self.states["/initialized/behaviour/operations/save"].setEnter(self._initialized_behaviour_operations_save_enter)
        
        # state /initialized/behaviour/operations/service_register
        self.states["/initialized/behaviour/operations/service_register"] = State(108, "/initialized/behaviour/operations/service_register", self)
        self.states["/initialized/behaviour/operations/service_register"].setEnter(self._initialized_behaviour_operations_service_register_enter)
        
        # state /initialized/behaviour/operations/service_stop
        self.states["/initialized/behaviour/operations/service_stop"] = State(109, "/initialized/behaviour/operations/service_stop", self)
        self.states["/initialized/behaviour/operations/service_stop"].setEnter(self._initialized_behaviour_operations_service_stop_enter)
        
        # state /initialized/behaviour/wait_for_action
        self.states["/initialized/behaviour/wait_for_action"] = State(110, "/initialized/behaviour/wait_for_action", self)
        
        # state /initialized/behaviour/wait_for_action/disconnected
        self.states["/initialized/behaviour/wait_for_action/disconnected"] = State(111, "/initialized/behaviour/wait_for_action/disconnected", self)
        
        # state /initialized/behaviour/wait_for_action/connected
        self.states["/initialized/behaviour/wait_for_action/connected"] = State(112, "/initialized/behaviour/wait_for_action/connected", self)
        
        # state /initialized/behaviour/wait_for_action/megamodelling
        self.states["/initialized/behaviour/wait_for_action/megamodelling"] = State(113, "/initialized/behaviour/wait_for_action/megamodelling", self)
        
        # state /initialized/behaviour/wait_for_action/service
        self.states["/initialized/behaviour/wait_for_action/service"] = State(114, "/initialized/behaviour/wait_for_action/service", self)
        
        # state /initialized/behaviour/wait_for_action/modelling
        self.states["/initialized/behaviour/wait_for_action/modelling"] = State(115, "/initialized/behaviour/wait_for_action/modelling", self)
        
        # state /initialized/behaviour/wait_for_action/modelling/recognized
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"] = State(116, "/initialized/behaviour/wait_for_action/modelling/recognized", self)
        
        # state /initialized/behaviour/wait_for_action/modelling/recognized/manual
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"] = State(117, "/initialized/behaviour/wait_for_action/modelling/recognized/manual", self)
        
        # state /initialized/behaviour/wait_for_action/modelling/recognized/scripted
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized/scripted"] = State(118, "/initialized/behaviour/wait_for_action/modelling/recognized/scripted", self)
        
        # state /initialized/behaviour/wait_for_action/finished
        self.states["/initialized/behaviour/wait_for_action/finished"] = State(119, "/initialized/behaviour/wait_for_action/finished", self)
        
        # state /initialized/behaviour/wait_for_action/history
        self.states["/initialized/behaviour/wait_for_action/history"] = DeepHistoryState(120, "/initialized/behaviour/wait_for_action/history", self)
        
        # state /initialized/behaviour/going_manual
        self.states["/initialized/behaviour/going_manual"] = State(121, "/initialized/behaviour/going_manual", self)
        
        # state /initialized/behaviour/going_manual/init
        self.states["/initialized/behaviour/going_manual/init"] = State(122, "/initialized/behaviour/going_manual/init", self)
        self.states["/initialized/behaviour/going_manual/init"].setEnter(self._initialized_behaviour_going_manual_init_enter)
        
        # state /initialized/behaviour/going_manual/search
        self.states["/initialized/behaviour/going_manual/search"] = State(123, "/initialized/behaviour/going_manual/search", self)
        self.states["/initialized/behaviour/going_manual/search"].setEnter(self._initialized_behaviour_going_manual_search_enter)
        
        # state /initialized/behaviour/going_manual/OK
        self.states["/initialized/behaviour/going_manual/OK"] = State(124, "/initialized/behaviour/going_manual/OK", self)
        self.states["/initialized/behaviour/going_manual/OK"].setEnter(self._initialized_behaviour_going_manual_OK_enter)
        
        # state /initialized/behaviour/going_scripted
        self.states["/initialized/behaviour/going_scripted"] = State(125, "/initialized/behaviour/going_scripted", self)
        self.states["/initialized/behaviour/going_scripted"].setEnter(self._initialized_behaviour_going_scripted_enter)
        
        # state /initialized/behaviour/leaving_manual
        self.states["/initialized/behaviour/leaving_manual"] = State(126, "/initialized/behaviour/leaving_manual", self)
        self.states["/initialized/behaviour/leaving_manual"].setEnter(self._initialized_behaviour_leaving_manual_enter)
        
        # state /initialized/behaviour/leaving_manual_drop
        self.states["/initialized/behaviour/leaving_manual_drop"] = State(127, "/initialized/behaviour/leaving_manual_drop", self)
        self.states["/initialized/behaviour/leaving_manual_drop"].setEnter(self._initialized_behaviour_leaving_manual_drop_enter)
        
        # state /initialized/queue
        self.states["/initialized/queue"] = State(128, "/initialized/queue", self)
        
        # state /initialized/queue/queue
        self.states["/initialized/queue/queue"] = State(129, "/initialized/queue/queue", self)
        
        # add children
        self.states[""].addChild(self.states["/init"])
        self.states[""].addChild(self.states["/waiting"])
        self.states[""].addChild(self.states["/initialized"])
        self.states["/initialized"].addChild(self.states["/initialized/http_mapper"])
        self.states["/initialized"].addChild(self.states["/initialized/behaviour"])
        self.states["/initialized"].addChild(self.states["/initialized/queue"])
        self.states["/initialized/http_mapper"].addChild(self.states["/initialized/http_mapper/init"])
        self.states["/initialized/http_mapper"].addChild(self.states["/initialized/http_mapper/finished"])
        self.states["/initialized/behaviour"].addChild(self.states["/initialized/behaviour/init"])
        self.states["/initialized/behaviour"].addChild(self.states["/initialized/behaviour/operations"])
        self.states["/initialized/behaviour"].addChild(self.states["/initialized/behaviour/wait_for_action"])
        self.states["/initialized/behaviour"].addChild(self.states["/initialized/behaviour/going_manual"])
        self.states["/initialized/behaviour"].addChild(self.states["/initialized/behaviour/going_scripted"])
        self.states["/initialized/behaviour"].addChild(self.states["/initialized/behaviour/leaving_manual"])
        self.states["/initialized/behaviour"].addChild(self.states["/initialized/behaviour/leaving_manual_drop"])
        self.states["/initialized/behaviour/init"].addChild(self.states["/initialized/behaviour/init/connect_http_client"])
        self.states["/initialized/behaviour/init"].addChild(self.states["/initialized/behaviour/init/waiting_http_client"])
        self.states["/initialized/behaviour/init"].addChild(self.states["/initialized/behaviour/init/wait_for_taskname_ack"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/history"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/login"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_list"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_add"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_delete"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_list_full"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/verify"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/alter_context"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_upload"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_overwrite"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/disconnect"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/user_logout"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/user_delete"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_render"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_rendered"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/transformation_between"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/transformation_signature"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/process_signature"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/permission_modify"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/permission_owner"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/permission_group"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/group_create"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/group_delete"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/group_owner_add"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/group_owner_delete"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/group_join"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/group_kick"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/group_list"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/admin_promote"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/admin_demote"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/conformance_delete"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/conformance_add"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/folder_create"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/model_types"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/element_list"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/element_list_nice"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/types"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/types_full"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/read_info"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/read_attrs"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/read_defined_attrs"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/instantiate"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/delete_element"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/attr_assign"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/attr_assign_code"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/attr_delete"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/attr_type"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/attr_name"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/attr_optional"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/read_outgoing"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/read_incoming"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/read_association_source"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/read_association_destination"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/connections_between"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/define_attribute"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/undefine_attribute"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/all_instances"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/save"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/service_register"])
        self.states["/initialized/behaviour/operations"].addChild(self.states["/initialized/behaviour/operations/service_stop"])
        self.states["/initialized/behaviour/operations/login"].addChild(self.states["/initialized/behaviour/operations/login/wait_prompt_1"])
        self.states["/initialized/behaviour/operations/login"].addChild(self.states["/initialized/behaviour/operations/login/wait_prompt_2"])
        self.states["/initialized/behaviour/operations/login"].addChild(self.states["/initialized/behaviour/operations/login/wait_prompt_existing"])
        self.states["/initialized/behaviour/operations/login"].addChild(self.states["/initialized/behaviour/operations/login/login_ok"])
        self.states["/initialized/behaviour/operations/model_add"].addChild(self.states["/initialized/behaviour/operations/model_add/send_metadata"])
        self.states["/initialized/behaviour/operations/verify"].addChild(self.states["/initialized/behaviour/operations/verify/waiting"])
        self.states["/initialized/behaviour/operations/model_upload"].addChild(self.states["/initialized/behaviour/operations/model_upload/send_metadata"])
        self.states["/initialized/behaviour/operations/model_upload"].addChild(self.states["/initialized/behaviour/operations/model_upload/send_model"])
        self.states["/initialized/behaviour/operations/model_overwrite"].addChild(self.states["/initialized/behaviour/operations/model_overwrite/send_metadata"])
        self.states["/initialized/behaviour/operations/model_overwrite"].addChild(self.states["/initialized/behaviour/operations/model_overwrite/send_model"])
        self.states["/initialized/behaviour/operations/store_on_scripted"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"])
        self.states["/initialized/behaviour/operations/store_on_scripted"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"])
        self.states["/initialized/behaviour/operations/store_on_scripted"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL"])
        self.states["/initialized/behaviour/operations/store_on_scripted"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute"])
        self.states["/initialized/behaviour/operations/store_on_scripted"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/process_execute"])
        self.states["/initialized/behaviour/operations/store_on_scripted"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/history"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/edit_metamodel"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"])
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"])
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/init"])
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"])
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"])
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc"])
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"])
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/init"])
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc"].addChild(self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"])
        self.states["/initialized/behaviour/operations/instantiate"].addChild(self.states["/initialized/behaviour/operations/instantiate/decide_node_or_edge"])
        self.states["/initialized/behaviour/operations/instantiate"].addChild(self.states["/initialized/behaviour/operations/instantiate/created"])
        self.states["/initialized/behaviour/wait_for_action"].addChild(self.states["/initialized/behaviour/wait_for_action/disconnected"])
        self.states["/initialized/behaviour/wait_for_action"].addChild(self.states["/initialized/behaviour/wait_for_action/connected"])
        self.states["/initialized/behaviour/wait_for_action"].addChild(self.states["/initialized/behaviour/wait_for_action/megamodelling"])
        self.states["/initialized/behaviour/wait_for_action"].addChild(self.states["/initialized/behaviour/wait_for_action/service"])
        self.states["/initialized/behaviour/wait_for_action"].addChild(self.states["/initialized/behaviour/wait_for_action/modelling"])
        self.states["/initialized/behaviour/wait_for_action"].addChild(self.states["/initialized/behaviour/wait_for_action/finished"])
        self.states["/initialized/behaviour/wait_for_action"].addChild(self.states["/initialized/behaviour/wait_for_action/history"])
        self.states["/initialized/behaviour/wait_for_action/modelling"].addChild(self.states["/initialized/behaviour/wait_for_action/modelling/recognized"])
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addChild(self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"])
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addChild(self.states["/initialized/behaviour/wait_for_action/modelling/recognized/scripted"])
        self.states["/initialized/behaviour/going_manual"].addChild(self.states["/initialized/behaviour/going_manual/init"])
        self.states["/initialized/behaviour/going_manual"].addChild(self.states["/initialized/behaviour/going_manual/search"])
        self.states["/initialized/behaviour/going_manual"].addChild(self.states["/initialized/behaviour/going_manual/OK"])
        self.states["/initialized/queue"].addChild(self.states["/initialized/queue/queue"])
        self.states[""].fixTree()
        self.states[""].default_state = self.states["/init"]
        self.states["/initialized/http_mapper"].default_state = self.states["/initialized/http_mapper/init"]
        self.states["/initialized/behaviour"].default_state = self.states["/initialized/behaviour/wait_for_action"]
        self.states["/initialized/behaviour/init"].default_state = self.states["/initialized/behaviour/init/connect_http_client"]
        self.states["/initialized/behaviour/operations"].default_state = self.states["/initialized/behaviour/operations/model_list"]
        self.states["/initialized/behaviour/operations/login"].default_state = self.states["/initialized/behaviour/operations/login/wait_prompt_1"]
        self.states["/initialized/behaviour/operations/model_add"].default_state = self.states["/initialized/behaviour/operations/model_add/send_metadata"]
        self.states["/initialized/behaviour/operations/verify"].default_state = self.states["/initialized/behaviour/operations/verify/waiting"]
        self.states["/initialized/behaviour/operations/model_upload"].default_state = self.states["/initialized/behaviour/operations/model_upload/send_metadata"]
        self.states["/initialized/behaviour/operations/model_overwrite"].default_state = self.states["/initialized/behaviour/operations/model_overwrite/send_metadata"]
        self.states["/initialized/behaviour/operations/store_on_scripted"].default_state = self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"]
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"].default_state = self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata"]
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"].default_state = self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata"]
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL"].default_state = self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata"]
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute"].default_state = self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation"]
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute"].default_state = self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/init"]
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"].default_state = self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc"]
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc"].default_state = self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/init"]
        self.states["/initialized/behaviour/operations/instantiate"].default_state = self.states["/initialized/behaviour/operations/instantiate/decide_node_or_edge"]
        self.states["/initialized/behaviour/wait_for_action"].default_state = self.states["/initialized/behaviour/wait_for_action/disconnected"]
        self.states["/initialized/behaviour/wait_for_action/modelling"].default_state = self.states["/initialized/behaviour/wait_for_action/modelling/recognized"]
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].default_state = self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"]
        self.states["/initialized/behaviour/going_manual"].default_state = self.states["/initialized/behaviour/going_manual/init"]
        self.states["/initialized/queue"].default_state = self.states["/initialized/queue/queue"]
        
        # transition /init
        _init_0 = Transition(self, self.states["/init"], [self.states["/init"]])
        _init_0.setAction(self._init_0_exec)
        _init_0.setTrigger(Event("instance_created", None))
        self.states["/init"].addTransition(_init_0)
        _init_1 = Transition(self, self.states["/init"], [self.states["/waiting"]])
        _init_1.setTrigger(None)
        _init_1.setGuard(self._init_1_guard)
        self.states["/init"].addTransition(_init_1)
        
        # transition /waiting
        _waiting_0 = Transition(self, self.states["/waiting"], [self.states["/initialized"]])
        _waiting_0.setTrigger(Event("http_client_initialized", None))
        self.states["/waiting"].addTransition(_waiting_0)
        
        # transition /initialized/http_mapper/init
        _initialized_http_mapper_init_0 = Transition(self, self.states["/initialized/http_mapper/init"], [self.states["/initialized/http_mapper/init"]])
        _initialized_http_mapper_init_0.setAction(self._initialized_http_mapper_init_0_exec)
        _initialized_http_mapper_init_0.setTrigger(Event("request", None))
        _initialized_http_mapper_init_0.setGuard(self._initialized_http_mapper_init_0_guard)
        self.states["/initialized/http_mapper/init"].addTransition(_initialized_http_mapper_init_0)
        _initialized_http_mapper_init_1 = Transition(self, self.states["/initialized/http_mapper/init"], [self.states["/initialized/http_mapper/init"]])
        _initialized_http_mapper_init_1.setAction(self._initialized_http_mapper_init_1_exec)
        _initialized_http_mapper_init_1.setTrigger(Event("request", None))
        _initialized_http_mapper_init_1.setGuard(self._initialized_http_mapper_init_1_guard)
        self.states["/initialized/http_mapper/init"].addTransition(_initialized_http_mapper_init_1)
        _initialized_http_mapper_init_2 = Transition(self, self.states["/initialized/http_mapper/init"], [self.states["/initialized/http_mapper/init"]])
        _initialized_http_mapper_init_2.setAction(self._initialized_http_mapper_init_2_exec)
        _initialized_http_mapper_init_2.setTrigger(Event("request_raw", None))
        self.states["/initialized/http_mapper/init"].addTransition(_initialized_http_mapper_init_2)
        _initialized_http_mapper_init_3 = Transition(self, self.states["/initialized/http_mapper/init"], [self.states["/initialized/http_mapper/init"]])
        _initialized_http_mapper_init_3.setAction(self._initialized_http_mapper_init_3_exec)
        _initialized_http_mapper_init_3.setTrigger(Event("HTTP_output", None))
        _initialized_http_mapper_init_3.setGuard(self._initialized_http_mapper_init_3_guard)
        self.states["/initialized/http_mapper/init"].addTransition(_initialized_http_mapper_init_3)
        _initialized_http_mapper_init_4 = Transition(self, self.states["/initialized/http_mapper/init"], [self.states["/initialized/http_mapper/finished"]])
        _initialized_http_mapper_init_4.setAction(self._initialized_http_mapper_init_4_exec)
        _initialized_http_mapper_init_4.setTrigger(Event("HTTP_output", None))
        _initialized_http_mapper_init_4.setGuard(self._initialized_http_mapper_init_4_guard)
        self.states["/initialized/http_mapper/init"].addTransition(_initialized_http_mapper_init_4)
        
        # transition /initialized/behaviour/init/connect_http_client
        _initialized_behaviour_init_connect_http_client_0 = Transition(self, self.states["/initialized/behaviour/init/connect_http_client"], [self.states["/initialized/behaviour/init/waiting_http_client"]])
        _initialized_behaviour_init_connect_http_client_0.setAction(self._initialized_behaviour_init_connect_http_client_0_exec)
        _initialized_behaviour_init_connect_http_client_0.setTrigger(None)
        _initialized_behaviour_init_connect_http_client_0.setGuard(self._initialized_behaviour_init_connect_http_client_0_guard)
        self.states["/initialized/behaviour/init/connect_http_client"].addTransition(_initialized_behaviour_init_connect_http_client_0)
        _initialized_behaviour_init_connect_http_client_1 = Transition(self, self.states["/initialized/behaviour/init/connect_http_client"], [self.states["/initialized/behaviour/wait_for_action/connected"]])
        _initialized_behaviour_init_connect_http_client_1.setAction(self._initialized_behaviour_init_connect_http_client_1_exec)
        _initialized_behaviour_init_connect_http_client_1.setTrigger(None)
        _initialized_behaviour_init_connect_http_client_1.setGuard(self._initialized_behaviour_init_connect_http_client_1_guard)
        self.states["/initialized/behaviour/init/connect_http_client"].addTransition(_initialized_behaviour_init_connect_http_client_1)
        
        # transition /initialized/behaviour/init/waiting_http_client
        _initialized_behaviour_init_waiting_http_client_0 = Transition(self, self.states["/initialized/behaviour/init/waiting_http_client"], [self.states["/initialized/behaviour/init/wait_for_taskname_ack"]])
        _initialized_behaviour_init_waiting_http_client_0.setAction(self._initialized_behaviour_init_waiting_http_client_0_exec)
        _initialized_behaviour_init_waiting_http_client_0.setTrigger(Event("http_client_ready", None))
        self.states["/initialized/behaviour/init/waiting_http_client"].addTransition(_initialized_behaviour_init_waiting_http_client_0)
        _initialized_behaviour_init_waiting_http_client_1 = Transition(self, self.states["/initialized/behaviour/init/waiting_http_client"], [self.states["/initialized/behaviour/wait_for_action/disconnected"]])
        _initialized_behaviour_init_waiting_http_client_1.setAction(self._initialized_behaviour_init_waiting_http_client_1_exec)
        _initialized_behaviour_init_waiting_http_client_1.setTrigger(Event("http_client_timeout", None))
        self.states["/initialized/behaviour/init/waiting_http_client"].addTransition(_initialized_behaviour_init_waiting_http_client_1)
        
        # transition /initialized/behaviour/init/wait_for_taskname_ack
        _initialized_behaviour_init_wait_for_taskname_ack_0 = Transition(self, self.states["/initialized/behaviour/init/wait_for_taskname_ack"], [self.states["/initialized/behaviour/init/connect_http_client"]])
        _initialized_behaviour_init_wait_for_taskname_ack_0.setTrigger(None)
        _initialized_behaviour_init_wait_for_taskname_ack_0.setGuard(self._initialized_behaviour_init_wait_for_taskname_ack_0_guard)
        self.states["/initialized/behaviour/init/wait_for_taskname_ack"].addTransition(_initialized_behaviour_init_wait_for_taskname_ack_0)
        
        # transition /initialized/behaviour/operations/login/wait_prompt_1
        _initialized_behaviour_operations_login_wait_prompt_1_0 = Transition(self, self.states["/initialized/behaviour/operations/login/wait_prompt_1"], [self.states["/initialized/behaviour/operations/login/wait_prompt_2"]])
        _initialized_behaviour_operations_login_wait_prompt_1_0.setAction(self._initialized_behaviour_operations_login_wait_prompt_1_0_exec)
        _initialized_behaviour_operations_login_wait_prompt_1_0.setTrigger(None)
        _initialized_behaviour_operations_login_wait_prompt_1_0.setGuard(self._initialized_behaviour_operations_login_wait_prompt_1_0_guard)
        self.states["/initialized/behaviour/operations/login/wait_prompt_1"].addTransition(_initialized_behaviour_operations_login_wait_prompt_1_0)
        
        # transition /initialized/behaviour/operations/login/wait_prompt_2
        _initialized_behaviour_operations_login_wait_prompt_2_0 = Transition(self, self.states["/initialized/behaviour/operations/login/wait_prompt_2"], [self.states["/initialized/behaviour/operations/login/wait_prompt_existing"]])
        _initialized_behaviour_operations_login_wait_prompt_2_0.setAction(self._initialized_behaviour_operations_login_wait_prompt_2_0_exec)
        _initialized_behaviour_operations_login_wait_prompt_2_0.setTrigger(None)
        _initialized_behaviour_operations_login_wait_prompt_2_0.setGuard(self._initialized_behaviour_operations_login_wait_prompt_2_0_guard)
        self.states["/initialized/behaviour/operations/login/wait_prompt_2"].addTransition(_initialized_behaviour_operations_login_wait_prompt_2_0)
        _initialized_behaviour_operations_login_wait_prompt_2_1 = Transition(self, self.states["/initialized/behaviour/operations/login/wait_prompt_2"], [self.states["/initialized/behaviour/operations/login/wait_prompt_existing"]])
        _initialized_behaviour_operations_login_wait_prompt_2_1.setAction(self._initialized_behaviour_operations_login_wait_prompt_2_1_exec)
        _initialized_behaviour_operations_login_wait_prompt_2_1.setTrigger(None)
        _initialized_behaviour_operations_login_wait_prompt_2_1.setGuard(self._initialized_behaviour_operations_login_wait_prompt_2_1_guard)
        self.states["/initialized/behaviour/operations/login/wait_prompt_2"].addTransition(_initialized_behaviour_operations_login_wait_prompt_2_1)
        
        # transition /initialized/behaviour/operations/login/wait_prompt_existing
        _initialized_behaviour_operations_login_wait_prompt_existing_0 = Transition(self, self.states["/initialized/behaviour/operations/login/wait_prompt_existing"], [self.states["/initialized/behaviour/operations/login/wait_prompt_existing"]])
        _initialized_behaviour_operations_login_wait_prompt_existing_0.setAction(self._initialized_behaviour_operations_login_wait_prompt_existing_0_exec)
        _initialized_behaviour_operations_login_wait_prompt_existing_0.setTrigger(None)
        _initialized_behaviour_operations_login_wait_prompt_existing_0.setGuard(self._initialized_behaviour_operations_login_wait_prompt_existing_0_guard)
        self.states["/initialized/behaviour/operations/login/wait_prompt_existing"].addTransition(_initialized_behaviour_operations_login_wait_prompt_existing_0)
        _initialized_behaviour_operations_login_wait_prompt_existing_1 = Transition(self, self.states["/initialized/behaviour/operations/login/wait_prompt_existing"], [self.states["/initialized/behaviour/operations/login/wait_prompt_existing"]])
        _initialized_behaviour_operations_login_wait_prompt_existing_1.setTrigger(None)
        _initialized_behaviour_operations_login_wait_prompt_existing_1.setGuard(self._initialized_behaviour_operations_login_wait_prompt_existing_1_guard)
        self.states["/initialized/behaviour/operations/login/wait_prompt_existing"].addTransition(_initialized_behaviour_operations_login_wait_prompt_existing_1)
        _initialized_behaviour_operations_login_wait_prompt_existing_2 = Transition(self, self.states["/initialized/behaviour/operations/login/wait_prompt_existing"], [self.states["/initialized/behaviour/operations/login/login_ok"]])
        _initialized_behaviour_operations_login_wait_prompt_existing_2.setTrigger(None)
        _initialized_behaviour_operations_login_wait_prompt_existing_2.setGuard(self._initialized_behaviour_operations_login_wait_prompt_existing_2_guard)
        self.states["/initialized/behaviour/operations/login/wait_prompt_existing"].addTransition(_initialized_behaviour_operations_login_wait_prompt_existing_2)
        _initialized_behaviour_operations_login_wait_prompt_existing_3 = Transition(self, self.states["/initialized/behaviour/operations/login/wait_prompt_existing"], [self.states["/initialized/behaviour/wait_for_action/connected"]])
        _initialized_behaviour_operations_login_wait_prompt_existing_3.setAction(self._initialized_behaviour_operations_login_wait_prompt_existing_3_exec)
        _initialized_behaviour_operations_login_wait_prompt_existing_3.setTrigger(None)
        _initialized_behaviour_operations_login_wait_prompt_existing_3.setGuard(self._initialized_behaviour_operations_login_wait_prompt_existing_3_guard)
        self.states["/initialized/behaviour/operations/login/wait_prompt_existing"].addTransition(_initialized_behaviour_operations_login_wait_prompt_existing_3)
        
        # transition /initialized/behaviour/operations/login/login_ok
        _initialized_behaviour_operations_login_login_ok_0 = Transition(self, self.states["/initialized/behaviour/operations/login/login_ok"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_operations_login_login_ok_0.setAction(self._initialized_behaviour_operations_login_login_ok_0_exec)
        _initialized_behaviour_operations_login_login_ok_0.setTrigger(None)
        _initialized_behaviour_operations_login_login_ok_0.setGuard(self._initialized_behaviour_operations_login_login_ok_0_guard)
        self.states["/initialized/behaviour/operations/login/login_ok"].addTransition(_initialized_behaviour_operations_login_login_ok_0)
        
        # transition /initialized/behaviour/operations/model_list
        _initialized_behaviour_operations_model_list_0 = Transition(self, self.states["/initialized/behaviour/operations/model_list"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_list_0.setAction(self._initialized_behaviour_operations_model_list_0_exec)
        _initialized_behaviour_operations_model_list_0.setTrigger(None)
        _initialized_behaviour_operations_model_list_0.setGuard(self._initialized_behaviour_operations_model_list_0_guard)
        self.states["/initialized/behaviour/operations/model_list"].addTransition(_initialized_behaviour_operations_model_list_0)
        
        # transition /initialized/behaviour/operations/model_add/send_metadata
        _initialized_behaviour_operations_model_add_send_metadata_0 = Transition(self, self.states["/initialized/behaviour/operations/model_add/send_metadata"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_add_send_metadata_0.setAction(self._initialized_behaviour_operations_model_add_send_metadata_0_exec)
        _initialized_behaviour_operations_model_add_send_metadata_0.setTrigger(None)
        _initialized_behaviour_operations_model_add_send_metadata_0.setGuard(self._initialized_behaviour_operations_model_add_send_metadata_0_guard)
        self.states["/initialized/behaviour/operations/model_add/send_metadata"].addTransition(_initialized_behaviour_operations_model_add_send_metadata_0)
        
        # transition /initialized/behaviour/operations/model_delete
        _initialized_behaviour_operations_model_delete_0 = Transition(self, self.states["/initialized/behaviour/operations/model_delete"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_delete_0.setAction(self._initialized_behaviour_operations_model_delete_0_exec)
        _initialized_behaviour_operations_model_delete_0.setTrigger(None)
        _initialized_behaviour_operations_model_delete_0.setGuard(self._initialized_behaviour_operations_model_delete_0_guard)
        self.states["/initialized/behaviour/operations/model_delete"].addTransition(_initialized_behaviour_operations_model_delete_0)
        
        # transition /initialized/behaviour/operations/model_list_full
        _initialized_behaviour_operations_model_list_full_0 = Transition(self, self.states["/initialized/behaviour/operations/model_list_full"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_list_full_0.setAction(self._initialized_behaviour_operations_model_list_full_0_exec)
        _initialized_behaviour_operations_model_list_full_0.setTrigger(None)
        _initialized_behaviour_operations_model_list_full_0.setGuard(self._initialized_behaviour_operations_model_list_full_0_guard)
        self.states["/initialized/behaviour/operations/model_list_full"].addTransition(_initialized_behaviour_operations_model_list_full_0)
        
        # transition /initialized/behaviour/operations/verify/waiting
        _initialized_behaviour_operations_verify_waiting_0 = Transition(self, self.states["/initialized/behaviour/operations/verify/waiting"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_verify_waiting_0.setAction(self._initialized_behaviour_operations_verify_waiting_0_exec)
        _initialized_behaviour_operations_verify_waiting_0.setTrigger(None)
        _initialized_behaviour_operations_verify_waiting_0.setGuard(self._initialized_behaviour_operations_verify_waiting_0_guard)
        self.states["/initialized/behaviour/operations/verify/waiting"].addTransition(_initialized_behaviour_operations_verify_waiting_0)
        
        # transition /initialized/behaviour/operations/alter_context
        _initialized_behaviour_operations_alter_context_0 = Transition(self, self.states["/initialized/behaviour/operations/alter_context"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_alter_context_0.setAction(self._initialized_behaviour_operations_alter_context_0_exec)
        _initialized_behaviour_operations_alter_context_0.setTrigger(None)
        self.states["/initialized/behaviour/operations/alter_context"].addTransition(_initialized_behaviour_operations_alter_context_0)
        
        # transition /initialized/behaviour/operations/model_upload/send_metadata
        _initialized_behaviour_operations_model_upload_send_metadata_0 = Transition(self, self.states["/initialized/behaviour/operations/model_upload/send_metadata"], [self.states["/initialized/behaviour/operations/model_upload/send_model"]])
        _initialized_behaviour_operations_model_upload_send_metadata_0.setTrigger(None)
        _initialized_behaviour_operations_model_upload_send_metadata_0.setGuard(self._initialized_behaviour_operations_model_upload_send_metadata_0_guard)
        self.states["/initialized/behaviour/operations/model_upload/send_metadata"].addTransition(_initialized_behaviour_operations_model_upload_send_metadata_0)
        
        # transition /initialized/behaviour/operations/model_upload/send_model
        _initialized_behaviour_operations_model_upload_send_model_0 = Transition(self, self.states["/initialized/behaviour/operations/model_upload/send_model"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_upload_send_model_0.setAction(self._initialized_behaviour_operations_model_upload_send_model_0_exec)
        _initialized_behaviour_operations_model_upload_send_model_0.setTrigger(None)
        _initialized_behaviour_operations_model_upload_send_model_0.setGuard(self._initialized_behaviour_operations_model_upload_send_model_0_guard)
        self.states["/initialized/behaviour/operations/model_upload/send_model"].addTransition(_initialized_behaviour_operations_model_upload_send_model_0)
        
        # transition /initialized/behaviour/operations/model_overwrite/send_metadata
        _initialized_behaviour_operations_model_overwrite_send_metadata_0 = Transition(self, self.states["/initialized/behaviour/operations/model_overwrite/send_metadata"], [self.states["/initialized/behaviour/operations/model_overwrite/send_model"]])
        _initialized_behaviour_operations_model_overwrite_send_metadata_0.setTrigger(None)
        _initialized_behaviour_operations_model_overwrite_send_metadata_0.setGuard(self._initialized_behaviour_operations_model_overwrite_send_metadata_0_guard)
        self.states["/initialized/behaviour/operations/model_overwrite/send_metadata"].addTransition(_initialized_behaviour_operations_model_overwrite_send_metadata_0)
        
        # transition /initialized/behaviour/operations/model_overwrite/send_model
        _initialized_behaviour_operations_model_overwrite_send_model_0 = Transition(self, self.states["/initialized/behaviour/operations/model_overwrite/send_model"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_overwrite_send_model_0.setAction(self._initialized_behaviour_operations_model_overwrite_send_model_0_exec)
        _initialized_behaviour_operations_model_overwrite_send_model_0.setTrigger(None)
        _initialized_behaviour_operations_model_overwrite_send_model_0.setGuard(self._initialized_behaviour_operations_model_overwrite_send_model_0_guard)
        self.states["/initialized/behaviour/operations/model_overwrite/send_model"].addTransition(_initialized_behaviour_operations_model_overwrite_send_model_0)
        
        # transition /initialized/behaviour/operations/disconnect
        _initialized_behaviour_operations_disconnect_0 = Transition(self, self.states["/initialized/behaviour/operations/disconnect"], [self.states["/initialized/behaviour/wait_for_action/finished"]])
        _initialized_behaviour_operations_disconnect_0.setAction(self._initialized_behaviour_operations_disconnect_0_exec)
        _initialized_behaviour_operations_disconnect_0.setTrigger(None)
        _initialized_behaviour_operations_disconnect_0.setGuard(self._initialized_behaviour_operations_disconnect_0_guard)
        self.states["/initialized/behaviour/operations/disconnect"].addTransition(_initialized_behaviour_operations_disconnect_0)
        
        # transition /initialized/behaviour/operations/user_logout
        _initialized_behaviour_operations_user_logout_0 = Transition(self, self.states["/initialized/behaviour/operations/user_logout"], [self.states["/initialized/behaviour/wait_for_action/connected"]])
        _initialized_behaviour_operations_user_logout_0.setAction(self._initialized_behaviour_operations_user_logout_0_exec)
        _initialized_behaviour_operations_user_logout_0.setTrigger(None)
        _initialized_behaviour_operations_user_logout_0.setGuard(self._initialized_behaviour_operations_user_logout_0_guard)
        self.states["/initialized/behaviour/operations/user_logout"].addTransition(_initialized_behaviour_operations_user_logout_0)
        
        # transition /initialized/behaviour/operations/user_delete
        _initialized_behaviour_operations_user_delete_0 = Transition(self, self.states["/initialized/behaviour/operations/user_delete"], [self.states["/initialized/behaviour/wait_for_action/finished"]])
        _initialized_behaviour_operations_user_delete_0.setAction(self._initialized_behaviour_operations_user_delete_0_exec)
        _initialized_behaviour_operations_user_delete_0.setTrigger(None)
        _initialized_behaviour_operations_user_delete_0.setGuard(self._initialized_behaviour_operations_user_delete_0_guard)
        self.states["/initialized/behaviour/operations/user_delete"].addTransition(_initialized_behaviour_operations_user_delete_0)
        
        # transition /initialized/behaviour/operations/model_render
        _initialized_behaviour_operations_model_render_0 = Transition(self, self.states["/initialized/behaviour/operations/model_render"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_render_0.setAction(self._initialized_behaviour_operations_model_render_0_exec)
        _initialized_behaviour_operations_model_render_0.setTrigger(None)
        _initialized_behaviour_operations_model_render_0.setGuard(self._initialized_behaviour_operations_model_render_0_guard)
        self.states["/initialized/behaviour/operations/model_render"].addTransition(_initialized_behaviour_operations_model_render_0)
        
        # transition /initialized/behaviour/operations/model_rendered
        _initialized_behaviour_operations_model_rendered_0 = Transition(self, self.states["/initialized/behaviour/operations/model_rendered"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_rendered_0.setAction(self._initialized_behaviour_operations_model_rendered_0_exec)
        _initialized_behaviour_operations_model_rendered_0.setTrigger(None)
        _initialized_behaviour_operations_model_rendered_0.setGuard(self._initialized_behaviour_operations_model_rendered_0_guard)
        self.states["/initialized/behaviour/operations/model_rendered"].addTransition(_initialized_behaviour_operations_model_rendered_0)
        
        # transition /initialized/behaviour/operations/transformation_between
        _initialized_behaviour_operations_transformation_between_0 = Transition(self, self.states["/initialized/behaviour/operations/transformation_between"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_transformation_between_0.setAction(self._initialized_behaviour_operations_transformation_between_0_exec)
        _initialized_behaviour_operations_transformation_between_0.setTrigger(None)
        _initialized_behaviour_operations_transformation_between_0.setGuard(self._initialized_behaviour_operations_transformation_between_0_guard)
        self.states["/initialized/behaviour/operations/transformation_between"].addTransition(_initialized_behaviour_operations_transformation_between_0)
        
        # transition /initialized/behaviour/operations/transformation_signature
        _initialized_behaviour_operations_transformation_signature_0 = Transition(self, self.states["/initialized/behaviour/operations/transformation_signature"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_transformation_signature_0.setAction(self._initialized_behaviour_operations_transformation_signature_0_exec)
        _initialized_behaviour_operations_transformation_signature_0.setTrigger(None)
        _initialized_behaviour_operations_transformation_signature_0.setGuard(self._initialized_behaviour_operations_transformation_signature_0_guard)
        self.states["/initialized/behaviour/operations/transformation_signature"].addTransition(_initialized_behaviour_operations_transformation_signature_0)
        
        # transition /initialized/behaviour/operations/process_signature
        _initialized_behaviour_operations_process_signature_0 = Transition(self, self.states["/initialized/behaviour/operations/process_signature"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_process_signature_0.setAction(self._initialized_behaviour_operations_process_signature_0_exec)
        _initialized_behaviour_operations_process_signature_0.setTrigger(None)
        _initialized_behaviour_operations_process_signature_0.setGuard(self._initialized_behaviour_operations_process_signature_0_guard)
        self.states["/initialized/behaviour/operations/process_signature"].addTransition(_initialized_behaviour_operations_process_signature_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_metadata"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel"], [self.states["/initialized/behaviour/going_scripted"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_0)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/edit_metamodel"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_1)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT/send_model"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/edit_metamodel"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_metadata"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_AL/edit_metamodel
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_edit_metamodel_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/edit_metamodel"], [self.states["/initialized/behaviour/going_scripted"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_edit_metamodel_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_edit_metamodel_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_AL_edit_metamodel_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/edit_metamodel"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_AL_edit_metamodel_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/send_metadata"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel"], [self.states["/initialized/behaviour/going_scripted"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_0)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL/edit_metamodel"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/send_operation"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/dialog"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_0)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_2 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"], [self.states["/initialized/behaviour/going_scripted"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_2.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_2.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_2_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_2)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute/edit_model"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3)
        
        # transition /initialized/behaviour/operations/store_on_scripted/process_execute/init
        _initialized_behaviour_operations_store_on_scripted_process_execute_init_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/init"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_init_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_init_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_init_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/init"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_init_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/process_execute/executing
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_0.setAction(self._initialized_behaviour_operations_store_on_scripted_process_execute_executing_0_exec)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_executing_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_executing_0)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_1.setAction(self._initialized_behaviour_operations_store_on_scripted_process_execute_executing_1_exec)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_executing_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_executing_1)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_2 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_2.setAction(self._initialized_behaviour_operations_store_on_scripted_process_execute_executing_2_exec)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_2.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_2.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_executing_2_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_executing_2)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_3 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_3.setAction(self._initialized_behaviour_operations_store_on_scripted_process_execute_executing_3_exec)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_3.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_executing_3.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_executing_3_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_executing_3)
        
        # transition /initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/init
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_init_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/init"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_init_0.setAction(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_init_0_exec)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_init_0.setTrigger(None)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/init"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_init_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0.setAction(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0_exec)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1.setAction(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1_exec)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/sc/processing"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1)
        
        # transition /initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_0)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1.setAction(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1_exec)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_2 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"], [self.states["/initialized/behaviour/going_scripted"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_2.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_2.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_2_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting/op"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_2)
        
        # transition /initialized/behaviour/operations/permission_modify
        _initialized_behaviour_operations_permission_modify_0 = Transition(self, self.states["/initialized/behaviour/operations/permission_modify"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_permission_modify_0.setAction(self._initialized_behaviour_operations_permission_modify_0_exec)
        _initialized_behaviour_operations_permission_modify_0.setTrigger(None)
        _initialized_behaviour_operations_permission_modify_0.setGuard(self._initialized_behaviour_operations_permission_modify_0_guard)
        self.states["/initialized/behaviour/operations/permission_modify"].addTransition(_initialized_behaviour_operations_permission_modify_0)
        
        # transition /initialized/behaviour/operations/permission_owner
        _initialized_behaviour_operations_permission_owner_0 = Transition(self, self.states["/initialized/behaviour/operations/permission_owner"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_permission_owner_0.setAction(self._initialized_behaviour_operations_permission_owner_0_exec)
        _initialized_behaviour_operations_permission_owner_0.setTrigger(None)
        _initialized_behaviour_operations_permission_owner_0.setGuard(self._initialized_behaviour_operations_permission_owner_0_guard)
        self.states["/initialized/behaviour/operations/permission_owner"].addTransition(_initialized_behaviour_operations_permission_owner_0)
        
        # transition /initialized/behaviour/operations/permission_group
        _initialized_behaviour_operations_permission_group_0 = Transition(self, self.states["/initialized/behaviour/operations/permission_group"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_permission_group_0.setAction(self._initialized_behaviour_operations_permission_group_0_exec)
        _initialized_behaviour_operations_permission_group_0.setTrigger(None)
        _initialized_behaviour_operations_permission_group_0.setGuard(self._initialized_behaviour_operations_permission_group_0_guard)
        self.states["/initialized/behaviour/operations/permission_group"].addTransition(_initialized_behaviour_operations_permission_group_0)
        
        # transition /initialized/behaviour/operations/group_create
        _initialized_behaviour_operations_group_create_0 = Transition(self, self.states["/initialized/behaviour/operations/group_create"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_group_create_0.setAction(self._initialized_behaviour_operations_group_create_0_exec)
        _initialized_behaviour_operations_group_create_0.setTrigger(None)
        _initialized_behaviour_operations_group_create_0.setGuard(self._initialized_behaviour_operations_group_create_0_guard)
        self.states["/initialized/behaviour/operations/group_create"].addTransition(_initialized_behaviour_operations_group_create_0)
        
        # transition /initialized/behaviour/operations/group_delete
        _initialized_behaviour_operations_group_delete_0 = Transition(self, self.states["/initialized/behaviour/operations/group_delete"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_group_delete_0.setAction(self._initialized_behaviour_operations_group_delete_0_exec)
        _initialized_behaviour_operations_group_delete_0.setTrigger(None)
        _initialized_behaviour_operations_group_delete_0.setGuard(self._initialized_behaviour_operations_group_delete_0_guard)
        self.states["/initialized/behaviour/operations/group_delete"].addTransition(_initialized_behaviour_operations_group_delete_0)
        
        # transition /initialized/behaviour/operations/group_owner_add
        _initialized_behaviour_operations_group_owner_add_0 = Transition(self, self.states["/initialized/behaviour/operations/group_owner_add"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_group_owner_add_0.setAction(self._initialized_behaviour_operations_group_owner_add_0_exec)
        _initialized_behaviour_operations_group_owner_add_0.setTrigger(None)
        _initialized_behaviour_operations_group_owner_add_0.setGuard(self._initialized_behaviour_operations_group_owner_add_0_guard)
        self.states["/initialized/behaviour/operations/group_owner_add"].addTransition(_initialized_behaviour_operations_group_owner_add_0)
        
        # transition /initialized/behaviour/operations/group_owner_delete
        _initialized_behaviour_operations_group_owner_delete_0 = Transition(self, self.states["/initialized/behaviour/operations/group_owner_delete"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_group_owner_delete_0.setAction(self._initialized_behaviour_operations_group_owner_delete_0_exec)
        _initialized_behaviour_operations_group_owner_delete_0.setTrigger(None)
        _initialized_behaviour_operations_group_owner_delete_0.setGuard(self._initialized_behaviour_operations_group_owner_delete_0_guard)
        self.states["/initialized/behaviour/operations/group_owner_delete"].addTransition(_initialized_behaviour_operations_group_owner_delete_0)
        
        # transition /initialized/behaviour/operations/group_join
        _initialized_behaviour_operations_group_join_0 = Transition(self, self.states["/initialized/behaviour/operations/group_join"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_group_join_0.setAction(self._initialized_behaviour_operations_group_join_0_exec)
        _initialized_behaviour_operations_group_join_0.setTrigger(None)
        _initialized_behaviour_operations_group_join_0.setGuard(self._initialized_behaviour_operations_group_join_0_guard)
        self.states["/initialized/behaviour/operations/group_join"].addTransition(_initialized_behaviour_operations_group_join_0)
        
        # transition /initialized/behaviour/operations/group_kick
        _initialized_behaviour_operations_group_kick_0 = Transition(self, self.states["/initialized/behaviour/operations/group_kick"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_group_kick_0.setAction(self._initialized_behaviour_operations_group_kick_0_exec)
        _initialized_behaviour_operations_group_kick_0.setTrigger(None)
        _initialized_behaviour_operations_group_kick_0.setGuard(self._initialized_behaviour_operations_group_kick_0_guard)
        self.states["/initialized/behaviour/operations/group_kick"].addTransition(_initialized_behaviour_operations_group_kick_0)
        
        # transition /initialized/behaviour/operations/group_list
        _initialized_behaviour_operations_group_list_0 = Transition(self, self.states["/initialized/behaviour/operations/group_list"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_group_list_0.setAction(self._initialized_behaviour_operations_group_list_0_exec)
        _initialized_behaviour_operations_group_list_0.setTrigger(None)
        _initialized_behaviour_operations_group_list_0.setGuard(self._initialized_behaviour_operations_group_list_0_guard)
        self.states["/initialized/behaviour/operations/group_list"].addTransition(_initialized_behaviour_operations_group_list_0)
        
        # transition /initialized/behaviour/operations/admin_promote
        _initialized_behaviour_operations_admin_promote_0 = Transition(self, self.states["/initialized/behaviour/operations/admin_promote"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_admin_promote_0.setAction(self._initialized_behaviour_operations_admin_promote_0_exec)
        _initialized_behaviour_operations_admin_promote_0.setTrigger(None)
        _initialized_behaviour_operations_admin_promote_0.setGuard(self._initialized_behaviour_operations_admin_promote_0_guard)
        self.states["/initialized/behaviour/operations/admin_promote"].addTransition(_initialized_behaviour_operations_admin_promote_0)
        
        # transition /initialized/behaviour/operations/admin_demote
        _initialized_behaviour_operations_admin_demote_0 = Transition(self, self.states["/initialized/behaviour/operations/admin_demote"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_admin_demote_0.setAction(self._initialized_behaviour_operations_admin_demote_0_exec)
        _initialized_behaviour_operations_admin_demote_0.setTrigger(None)
        _initialized_behaviour_operations_admin_demote_0.setGuard(self._initialized_behaviour_operations_admin_demote_0_guard)
        self.states["/initialized/behaviour/operations/admin_demote"].addTransition(_initialized_behaviour_operations_admin_demote_0)
        
        # transition /initialized/behaviour/operations/conformance_delete
        _initialized_behaviour_operations_conformance_delete_0 = Transition(self, self.states["/initialized/behaviour/operations/conformance_delete"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_conformance_delete_0.setAction(self._initialized_behaviour_operations_conformance_delete_0_exec)
        _initialized_behaviour_operations_conformance_delete_0.setTrigger(None)
        _initialized_behaviour_operations_conformance_delete_0.setGuard(self._initialized_behaviour_operations_conformance_delete_0_guard)
        self.states["/initialized/behaviour/operations/conformance_delete"].addTransition(_initialized_behaviour_operations_conformance_delete_0)
        
        # transition /initialized/behaviour/operations/conformance_add
        _initialized_behaviour_operations_conformance_add_0 = Transition(self, self.states["/initialized/behaviour/operations/conformance_add"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_conformance_add_0.setAction(self._initialized_behaviour_operations_conformance_add_0_exec)
        _initialized_behaviour_operations_conformance_add_0.setTrigger(None)
        _initialized_behaviour_operations_conformance_add_0.setGuard(self._initialized_behaviour_operations_conformance_add_0_guard)
        self.states["/initialized/behaviour/operations/conformance_add"].addTransition(_initialized_behaviour_operations_conformance_add_0)
        
        # transition /initialized/behaviour/operations/folder_create
        _initialized_behaviour_operations_folder_create_0 = Transition(self, self.states["/initialized/behaviour/operations/folder_create"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_folder_create_0.setAction(self._initialized_behaviour_operations_folder_create_0_exec)
        _initialized_behaviour_operations_folder_create_0.setTrigger(None)
        _initialized_behaviour_operations_folder_create_0.setGuard(self._initialized_behaviour_operations_folder_create_0_guard)
        self.states["/initialized/behaviour/operations/folder_create"].addTransition(_initialized_behaviour_operations_folder_create_0)
        
        # transition /initialized/behaviour/operations/model_types
        _initialized_behaviour_operations_model_types_0 = Transition(self, self.states["/initialized/behaviour/operations/model_types"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_model_types_0.setAction(self._initialized_behaviour_operations_model_types_0_exec)
        _initialized_behaviour_operations_model_types_0.setTrigger(None)
        _initialized_behaviour_operations_model_types_0.setGuard(self._initialized_behaviour_operations_model_types_0_guard)
        self.states["/initialized/behaviour/operations/model_types"].addTransition(_initialized_behaviour_operations_model_types_0)
        
        # transition /initialized/behaviour/operations/element_list
        _initialized_behaviour_operations_element_list_0 = Transition(self, self.states["/initialized/behaviour/operations/element_list"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_element_list_0.setAction(self._initialized_behaviour_operations_element_list_0_exec)
        _initialized_behaviour_operations_element_list_0.setTrigger(None)
        _initialized_behaviour_operations_element_list_0.setGuard(self._initialized_behaviour_operations_element_list_0_guard)
        self.states["/initialized/behaviour/operations/element_list"].addTransition(_initialized_behaviour_operations_element_list_0)
        
        # transition /initialized/behaviour/operations/element_list_nice
        _initialized_behaviour_operations_element_list_nice_0 = Transition(self, self.states["/initialized/behaviour/operations/element_list_nice"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_element_list_nice_0.setAction(self._initialized_behaviour_operations_element_list_nice_0_exec)
        _initialized_behaviour_operations_element_list_nice_0.setTrigger(None)
        _initialized_behaviour_operations_element_list_nice_0.setGuard(self._initialized_behaviour_operations_element_list_nice_0_guard)
        self.states["/initialized/behaviour/operations/element_list_nice"].addTransition(_initialized_behaviour_operations_element_list_nice_0)
        
        # transition /initialized/behaviour/operations/types
        _initialized_behaviour_operations_types_0 = Transition(self, self.states["/initialized/behaviour/operations/types"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_types_0.setAction(self._initialized_behaviour_operations_types_0_exec)
        _initialized_behaviour_operations_types_0.setTrigger(None)
        _initialized_behaviour_operations_types_0.setGuard(self._initialized_behaviour_operations_types_0_guard)
        self.states["/initialized/behaviour/operations/types"].addTransition(_initialized_behaviour_operations_types_0)
        
        # transition /initialized/behaviour/operations/types_full
        _initialized_behaviour_operations_types_full_0 = Transition(self, self.states["/initialized/behaviour/operations/types_full"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_types_full_0.setAction(self._initialized_behaviour_operations_types_full_0_exec)
        _initialized_behaviour_operations_types_full_0.setTrigger(None)
        _initialized_behaviour_operations_types_full_0.setGuard(self._initialized_behaviour_operations_types_full_0_guard)
        self.states["/initialized/behaviour/operations/types_full"].addTransition(_initialized_behaviour_operations_types_full_0)
        
        # transition /initialized/behaviour/operations/read_info
        _initialized_behaviour_operations_read_info_0 = Transition(self, self.states["/initialized/behaviour/operations/read_info"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_read_info_0.setAction(self._initialized_behaviour_operations_read_info_0_exec)
        _initialized_behaviour_operations_read_info_0.setTrigger(None)
        _initialized_behaviour_operations_read_info_0.setGuard(self._initialized_behaviour_operations_read_info_0_guard)
        self.states["/initialized/behaviour/operations/read_info"].addTransition(_initialized_behaviour_operations_read_info_0)
        
        # transition /initialized/behaviour/operations/read_attrs
        _initialized_behaviour_operations_read_attrs_0 = Transition(self, self.states["/initialized/behaviour/operations/read_attrs"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_read_attrs_0.setAction(self._initialized_behaviour_operations_read_attrs_0_exec)
        _initialized_behaviour_operations_read_attrs_0.setTrigger(None)
        _initialized_behaviour_operations_read_attrs_0.setGuard(self._initialized_behaviour_operations_read_attrs_0_guard)
        self.states["/initialized/behaviour/operations/read_attrs"].addTransition(_initialized_behaviour_operations_read_attrs_0)
        
        # transition /initialized/behaviour/operations/read_defined_attrs
        _initialized_behaviour_operations_read_defined_attrs_0 = Transition(self, self.states["/initialized/behaviour/operations/read_defined_attrs"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_read_defined_attrs_0.setAction(self._initialized_behaviour_operations_read_defined_attrs_0_exec)
        _initialized_behaviour_operations_read_defined_attrs_0.setTrigger(None)
        _initialized_behaviour_operations_read_defined_attrs_0.setGuard(self._initialized_behaviour_operations_read_defined_attrs_0_guard)
        self.states["/initialized/behaviour/operations/read_defined_attrs"].addTransition(_initialized_behaviour_operations_read_defined_attrs_0)
        
        # transition /initialized/behaviour/operations/instantiate/decide_node_or_edge
        _initialized_behaviour_operations_instantiate_decide_node_or_edge_0 = Transition(self, self.states["/initialized/behaviour/operations/instantiate/decide_node_or_edge"], [self.states["/initialized/behaviour/operations/instantiate/created"]])
        _initialized_behaviour_operations_instantiate_decide_node_or_edge_0.setAction(self._initialized_behaviour_operations_instantiate_decide_node_or_edge_0_exec)
        _initialized_behaviour_operations_instantiate_decide_node_or_edge_0.setTrigger(None)
        _initialized_behaviour_operations_instantiate_decide_node_or_edge_0.setGuard(self._initialized_behaviour_operations_instantiate_decide_node_or_edge_0_guard)
        self.states["/initialized/behaviour/operations/instantiate/decide_node_or_edge"].addTransition(_initialized_behaviour_operations_instantiate_decide_node_or_edge_0)
        _initialized_behaviour_operations_instantiate_decide_node_or_edge_1 = Transition(self, self.states["/initialized/behaviour/operations/instantiate/decide_node_or_edge"], [self.states["/initialized/behaviour/operations/instantiate/created"]])
        _initialized_behaviour_operations_instantiate_decide_node_or_edge_1.setAction(self._initialized_behaviour_operations_instantiate_decide_node_or_edge_1_exec)
        _initialized_behaviour_operations_instantiate_decide_node_or_edge_1.setTrigger(None)
        _initialized_behaviour_operations_instantiate_decide_node_or_edge_1.setGuard(self._initialized_behaviour_operations_instantiate_decide_node_or_edge_1_guard)
        self.states["/initialized/behaviour/operations/instantiate/decide_node_or_edge"].addTransition(_initialized_behaviour_operations_instantiate_decide_node_or_edge_1)
        
        # transition /initialized/behaviour/operations/instantiate/created
        _initialized_behaviour_operations_instantiate_created_0 = Transition(self, self.states["/initialized/behaviour/operations/instantiate/created"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_instantiate_created_0.setAction(self._initialized_behaviour_operations_instantiate_created_0_exec)
        _initialized_behaviour_operations_instantiate_created_0.setTrigger(None)
        _initialized_behaviour_operations_instantiate_created_0.setGuard(self._initialized_behaviour_operations_instantiate_created_0_guard)
        self.states["/initialized/behaviour/operations/instantiate/created"].addTransition(_initialized_behaviour_operations_instantiate_created_0)
        
        # transition /initialized/behaviour/operations/delete_element
        _initialized_behaviour_operations_delete_element_0 = Transition(self, self.states["/initialized/behaviour/operations/delete_element"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_delete_element_0.setAction(self._initialized_behaviour_operations_delete_element_0_exec)
        _initialized_behaviour_operations_delete_element_0.setTrigger(None)
        _initialized_behaviour_operations_delete_element_0.setGuard(self._initialized_behaviour_operations_delete_element_0_guard)
        self.states["/initialized/behaviour/operations/delete_element"].addTransition(_initialized_behaviour_operations_delete_element_0)
        
        # transition /initialized/behaviour/operations/attr_assign
        _initialized_behaviour_operations_attr_assign_0 = Transition(self, self.states["/initialized/behaviour/operations/attr_assign"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_attr_assign_0.setAction(self._initialized_behaviour_operations_attr_assign_0_exec)
        _initialized_behaviour_operations_attr_assign_0.setTrigger(None)
        _initialized_behaviour_operations_attr_assign_0.setGuard(self._initialized_behaviour_operations_attr_assign_0_guard)
        self.states["/initialized/behaviour/operations/attr_assign"].addTransition(_initialized_behaviour_operations_attr_assign_0)
        
        # transition /initialized/behaviour/operations/attr_assign_code
        _initialized_behaviour_operations_attr_assign_code_0 = Transition(self, self.states["/initialized/behaviour/operations/attr_assign_code"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_attr_assign_code_0.setAction(self._initialized_behaviour_operations_attr_assign_code_0_exec)
        _initialized_behaviour_operations_attr_assign_code_0.setTrigger(None)
        _initialized_behaviour_operations_attr_assign_code_0.setGuard(self._initialized_behaviour_operations_attr_assign_code_0_guard)
        self.states["/initialized/behaviour/operations/attr_assign_code"].addTransition(_initialized_behaviour_operations_attr_assign_code_0)
        
        # transition /initialized/behaviour/operations/attr_delete
        _initialized_behaviour_operations_attr_delete_0 = Transition(self, self.states["/initialized/behaviour/operations/attr_delete"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_attr_delete_0.setAction(self._initialized_behaviour_operations_attr_delete_0_exec)
        _initialized_behaviour_operations_attr_delete_0.setTrigger(None)
        _initialized_behaviour_operations_attr_delete_0.setGuard(self._initialized_behaviour_operations_attr_delete_0_guard)
        self.states["/initialized/behaviour/operations/attr_delete"].addTransition(_initialized_behaviour_operations_attr_delete_0)
        
        # transition /initialized/behaviour/operations/attr_type
        _initialized_behaviour_operations_attr_type_0 = Transition(self, self.states["/initialized/behaviour/operations/attr_type"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_attr_type_0.setAction(self._initialized_behaviour_operations_attr_type_0_exec)
        _initialized_behaviour_operations_attr_type_0.setTrigger(None)
        _initialized_behaviour_operations_attr_type_0.setGuard(self._initialized_behaviour_operations_attr_type_0_guard)
        self.states["/initialized/behaviour/operations/attr_type"].addTransition(_initialized_behaviour_operations_attr_type_0)
        
        # transition /initialized/behaviour/operations/attr_name
        _initialized_behaviour_operations_attr_name_0 = Transition(self, self.states["/initialized/behaviour/operations/attr_name"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_attr_name_0.setAction(self._initialized_behaviour_operations_attr_name_0_exec)
        _initialized_behaviour_operations_attr_name_0.setTrigger(None)
        _initialized_behaviour_operations_attr_name_0.setGuard(self._initialized_behaviour_operations_attr_name_0_guard)
        self.states["/initialized/behaviour/operations/attr_name"].addTransition(_initialized_behaviour_operations_attr_name_0)
        
        # transition /initialized/behaviour/operations/attr_optional
        _initialized_behaviour_operations_attr_optional_0 = Transition(self, self.states["/initialized/behaviour/operations/attr_optional"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_attr_optional_0.setAction(self._initialized_behaviour_operations_attr_optional_0_exec)
        _initialized_behaviour_operations_attr_optional_0.setTrigger(None)
        _initialized_behaviour_operations_attr_optional_0.setGuard(self._initialized_behaviour_operations_attr_optional_0_guard)
        self.states["/initialized/behaviour/operations/attr_optional"].addTransition(_initialized_behaviour_operations_attr_optional_0)
        
        # transition /initialized/behaviour/operations/read_outgoing
        _initialized_behaviour_operations_read_outgoing_0 = Transition(self, self.states["/initialized/behaviour/operations/read_outgoing"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_read_outgoing_0.setAction(self._initialized_behaviour_operations_read_outgoing_0_exec)
        _initialized_behaviour_operations_read_outgoing_0.setTrigger(None)
        _initialized_behaviour_operations_read_outgoing_0.setGuard(self._initialized_behaviour_operations_read_outgoing_0_guard)
        self.states["/initialized/behaviour/operations/read_outgoing"].addTransition(_initialized_behaviour_operations_read_outgoing_0)
        
        # transition /initialized/behaviour/operations/read_incoming
        _initialized_behaviour_operations_read_incoming_0 = Transition(self, self.states["/initialized/behaviour/operations/read_incoming"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_read_incoming_0.setAction(self._initialized_behaviour_operations_read_incoming_0_exec)
        _initialized_behaviour_operations_read_incoming_0.setTrigger(None)
        _initialized_behaviour_operations_read_incoming_0.setGuard(self._initialized_behaviour_operations_read_incoming_0_guard)
        self.states["/initialized/behaviour/operations/read_incoming"].addTransition(_initialized_behaviour_operations_read_incoming_0)
        
        # transition /initialized/behaviour/operations/read_association_source
        _initialized_behaviour_operations_read_association_source_0 = Transition(self, self.states["/initialized/behaviour/operations/read_association_source"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_read_association_source_0.setAction(self._initialized_behaviour_operations_read_association_source_0_exec)
        _initialized_behaviour_operations_read_association_source_0.setTrigger(None)
        _initialized_behaviour_operations_read_association_source_0.setGuard(self._initialized_behaviour_operations_read_association_source_0_guard)
        self.states["/initialized/behaviour/operations/read_association_source"].addTransition(_initialized_behaviour_operations_read_association_source_0)
        
        # transition /initialized/behaviour/operations/read_association_destination
        _initialized_behaviour_operations_read_association_destination_0 = Transition(self, self.states["/initialized/behaviour/operations/read_association_destination"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_read_association_destination_0.setAction(self._initialized_behaviour_operations_read_association_destination_0_exec)
        _initialized_behaviour_operations_read_association_destination_0.setTrigger(None)
        _initialized_behaviour_operations_read_association_destination_0.setGuard(self._initialized_behaviour_operations_read_association_destination_0_guard)
        self.states["/initialized/behaviour/operations/read_association_destination"].addTransition(_initialized_behaviour_operations_read_association_destination_0)
        
        # transition /initialized/behaviour/operations/connections_between
        _initialized_behaviour_operations_connections_between_0 = Transition(self, self.states["/initialized/behaviour/operations/connections_between"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_connections_between_0.setAction(self._initialized_behaviour_operations_connections_between_0_exec)
        _initialized_behaviour_operations_connections_between_0.setTrigger(None)
        _initialized_behaviour_operations_connections_between_0.setGuard(self._initialized_behaviour_operations_connections_between_0_guard)
        self.states["/initialized/behaviour/operations/connections_between"].addTransition(_initialized_behaviour_operations_connections_between_0)
        
        # transition /initialized/behaviour/operations/define_attribute
        _initialized_behaviour_operations_define_attribute_0 = Transition(self, self.states["/initialized/behaviour/operations/define_attribute"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_define_attribute_0.setAction(self._initialized_behaviour_operations_define_attribute_0_exec)
        _initialized_behaviour_operations_define_attribute_0.setTrigger(None)
        _initialized_behaviour_operations_define_attribute_0.setGuard(self._initialized_behaviour_operations_define_attribute_0_guard)
        self.states["/initialized/behaviour/operations/define_attribute"].addTransition(_initialized_behaviour_operations_define_attribute_0)
        
        # transition /initialized/behaviour/operations/undefine_attribute
        _initialized_behaviour_operations_undefine_attribute_0 = Transition(self, self.states["/initialized/behaviour/operations/undefine_attribute"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_undefine_attribute_0.setAction(self._initialized_behaviour_operations_undefine_attribute_0_exec)
        _initialized_behaviour_operations_undefine_attribute_0.setTrigger(None)
        _initialized_behaviour_operations_undefine_attribute_0.setGuard(self._initialized_behaviour_operations_undefine_attribute_0_guard)
        self.states["/initialized/behaviour/operations/undefine_attribute"].addTransition(_initialized_behaviour_operations_undefine_attribute_0)
        
        # transition /initialized/behaviour/operations/all_instances
        _initialized_behaviour_operations_all_instances_0 = Transition(self, self.states["/initialized/behaviour/operations/all_instances"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_all_instances_0.setAction(self._initialized_behaviour_operations_all_instances_0_exec)
        _initialized_behaviour_operations_all_instances_0.setTrigger(None)
        _initialized_behaviour_operations_all_instances_0.setGuard(self._initialized_behaviour_operations_all_instances_0_guard)
        self.states["/initialized/behaviour/operations/all_instances"].addTransition(_initialized_behaviour_operations_all_instances_0)
        
        # transition /initialized/behaviour/operations/save
        _initialized_behaviour_operations_save_0 = Transition(self, self.states["/initialized/behaviour/operations/save"], [self.states["/initialized/behaviour/operations/save"]])
        _initialized_behaviour_operations_save_0.setTrigger(None)
        _initialized_behaviour_operations_save_0.setGuard(self._initialized_behaviour_operations_save_0_guard)
        self.states["/initialized/behaviour/operations/save"].addTransition(_initialized_behaviour_operations_save_0)
        _initialized_behaviour_operations_save_1 = Transition(self, self.states["/initialized/behaviour/operations/save"], [self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"]])
        _initialized_behaviour_operations_save_1.setTrigger(None)
        _initialized_behaviour_operations_save_1.setGuard(self._initialized_behaviour_operations_save_1_guard)
        self.states["/initialized/behaviour/operations/save"].addTransition(_initialized_behaviour_operations_save_1)
        
        # transition /initialized/behaviour/operations/service_register
        _initialized_behaviour_operations_service_register_0 = Transition(self, self.states["/initialized/behaviour/operations/service_register"], [self.states["/initialized/behaviour/wait_for_action/service"]])
        _initialized_behaviour_operations_service_register_0.setAction(self._initialized_behaviour_operations_service_register_0_exec)
        _initialized_behaviour_operations_service_register_0.setTrigger(None)
        _initialized_behaviour_operations_service_register_0.setGuard(self._initialized_behaviour_operations_service_register_0_guard)
        self.states["/initialized/behaviour/operations/service_register"].addTransition(_initialized_behaviour_operations_service_register_0)
        
        # transition /initialized/behaviour/operations/service_stop
        _initialized_behaviour_operations_service_stop_0 = Transition(self, self.states["/initialized/behaviour/operations/service_stop"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_operations_service_stop_0.setTrigger(None)
        _initialized_behaviour_operations_service_stop_0.setGuard(self._initialized_behaviour_operations_service_stop_0_guard)
        self.states["/initialized/behaviour/operations/service_stop"].addTransition(_initialized_behaviour_operations_service_stop_0)
        
        # transition /initialized/behaviour/wait_for_action/disconnected
        _initialized_behaviour_wait_for_action_disconnected_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action/disconnected"], [self.states["/initialized/behaviour/init"]])
        _initialized_behaviour_wait_for_action_disconnected_0.setAction(self._initialized_behaviour_wait_for_action_disconnected_0_exec)
        _initialized_behaviour_wait_for_action_disconnected_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_disconnected_0.setGuard(self._initialized_behaviour_wait_for_action_disconnected_0_guard)
        self.states["/initialized/behaviour/wait_for_action/disconnected"].addTransition(_initialized_behaviour_wait_for_action_disconnected_0)
        
        # transition /initialized/behaviour/wait_for_action/connected
        _initialized_behaviour_wait_for_action_connected_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action/connected"], [self.states["/initialized/behaviour/operations/login"]])
        _initialized_behaviour_wait_for_action_connected_0.setAction(self._initialized_behaviour_wait_for_action_connected_0_exec)
        _initialized_behaviour_wait_for_action_connected_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_connected_0.setGuard(self._initialized_behaviour_wait_for_action_connected_0_guard)
        self.states["/initialized/behaviour/wait_for_action/connected"].addTransition(_initialized_behaviour_wait_for_action_connected_0)
        
        # transition /initialized/behaviour/wait_for_action/megamodelling
        _initialized_behaviour_wait_for_action_megamodelling_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/model_list"]])
        _initialized_behaviour_wait_for_action_megamodelling_0.setAction(self._initialized_behaviour_wait_for_action_megamodelling_0_exec)
        _initialized_behaviour_wait_for_action_megamodelling_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_0.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_0_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_0)
        _initialized_behaviour_wait_for_action_megamodelling_1 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/model_add"]])
        _initialized_behaviour_wait_for_action_megamodelling_1.setAction(self._initialized_behaviour_wait_for_action_megamodelling_1_exec)
        _initialized_behaviour_wait_for_action_megamodelling_1.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_1.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_1_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_1)
        _initialized_behaviour_wait_for_action_megamodelling_2 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/model_delete"]])
        _initialized_behaviour_wait_for_action_megamodelling_2.setAction(self._initialized_behaviour_wait_for_action_megamodelling_2_exec)
        _initialized_behaviour_wait_for_action_megamodelling_2.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_2.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_2_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_2)
        _initialized_behaviour_wait_for_action_megamodelling_3 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/model_list_full"]])
        _initialized_behaviour_wait_for_action_megamodelling_3.setAction(self._initialized_behaviour_wait_for_action_megamodelling_3_exec)
        _initialized_behaviour_wait_for_action_megamodelling_3.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_3.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_3_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_3)
        _initialized_behaviour_wait_for_action_megamodelling_4 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/verify"]])
        _initialized_behaviour_wait_for_action_megamodelling_4.setAction(self._initialized_behaviour_wait_for_action_megamodelling_4_exec)
        _initialized_behaviour_wait_for_action_megamodelling_4.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_4.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_4_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_4)
        _initialized_behaviour_wait_for_action_megamodelling_5 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/alter_context"]])
        _initialized_behaviour_wait_for_action_megamodelling_5.setAction(self._initialized_behaviour_wait_for_action_megamodelling_5_exec)
        _initialized_behaviour_wait_for_action_megamodelling_5.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_5.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_5_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_5)
        _initialized_behaviour_wait_for_action_megamodelling_6 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/model_overwrite"]])
        _initialized_behaviour_wait_for_action_megamodelling_6.setAction(self._initialized_behaviour_wait_for_action_megamodelling_6_exec)
        _initialized_behaviour_wait_for_action_megamodelling_6.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_6.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_6_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_6)
        _initialized_behaviour_wait_for_action_megamodelling_7 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/disconnect"]])
        _initialized_behaviour_wait_for_action_megamodelling_7.setAction(self._initialized_behaviour_wait_for_action_megamodelling_7_exec)
        _initialized_behaviour_wait_for_action_megamodelling_7.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_7.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_7_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_7)
        _initialized_behaviour_wait_for_action_megamodelling_8 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/user_logout"]])
        _initialized_behaviour_wait_for_action_megamodelling_8.setAction(self._initialized_behaviour_wait_for_action_megamodelling_8_exec)
        _initialized_behaviour_wait_for_action_megamodelling_8.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_8.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_8_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_8)
        _initialized_behaviour_wait_for_action_megamodelling_9 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/user_delete"]])
        _initialized_behaviour_wait_for_action_megamodelling_9.setAction(self._initialized_behaviour_wait_for_action_megamodelling_9_exec)
        _initialized_behaviour_wait_for_action_megamodelling_9.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_9.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_9_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_9)
        _initialized_behaviour_wait_for_action_megamodelling_10 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/model_render"]])
        _initialized_behaviour_wait_for_action_megamodelling_10.setAction(self._initialized_behaviour_wait_for_action_megamodelling_10_exec)
        _initialized_behaviour_wait_for_action_megamodelling_10.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_10.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_10_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_10)
        _initialized_behaviour_wait_for_action_megamodelling_11 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/model_rendered"]])
        _initialized_behaviour_wait_for_action_megamodelling_11.setAction(self._initialized_behaviour_wait_for_action_megamodelling_11_exec)
        _initialized_behaviour_wait_for_action_megamodelling_11.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_11.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_11_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_11)
        _initialized_behaviour_wait_for_action_megamodelling_12 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/transformation_between"]])
        _initialized_behaviour_wait_for_action_megamodelling_12.setAction(self._initialized_behaviour_wait_for_action_megamodelling_12_exec)
        _initialized_behaviour_wait_for_action_megamodelling_12.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_12.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_12_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_12)
        _initialized_behaviour_wait_for_action_megamodelling_13 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/transformation_signature"]])
        _initialized_behaviour_wait_for_action_megamodelling_13.setAction(self._initialized_behaviour_wait_for_action_megamodelling_13_exec)
        _initialized_behaviour_wait_for_action_megamodelling_13.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_13.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_13_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_13)
        _initialized_behaviour_wait_for_action_megamodelling_14 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/process_signature"]])
        _initialized_behaviour_wait_for_action_megamodelling_14.setAction(self._initialized_behaviour_wait_for_action_megamodelling_14_exec)
        _initialized_behaviour_wait_for_action_megamodelling_14.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_14.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_14_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_14)
        _initialized_behaviour_wait_for_action_megamodelling_15 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"]])
        _initialized_behaviour_wait_for_action_megamodelling_15.setAction(self._initialized_behaviour_wait_for_action_megamodelling_15_exec)
        _initialized_behaviour_wait_for_action_megamodelling_15.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_15.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_15_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_15)
        _initialized_behaviour_wait_for_action_megamodelling_16 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"]])
        _initialized_behaviour_wait_for_action_megamodelling_16.setAction(self._initialized_behaviour_wait_for_action_megamodelling_16_exec)
        _initialized_behaviour_wait_for_action_megamodelling_16.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_16.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_16_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_16)
        _initialized_behaviour_wait_for_action_megamodelling_17 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MANUAL"]])
        _initialized_behaviour_wait_for_action_megamodelling_17.setAction(self._initialized_behaviour_wait_for_action_megamodelling_17_exec)
        _initialized_behaviour_wait_for_action_megamodelling_17.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_17.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_17_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_17)
        _initialized_behaviour_wait_for_action_megamodelling_18 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_execute"]])
        _initialized_behaviour_wait_for_action_megamodelling_18.setAction(self._initialized_behaviour_wait_for_action_megamodelling_18_exec)
        _initialized_behaviour_wait_for_action_megamodelling_18.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_18.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_18_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_18)
        _initialized_behaviour_wait_for_action_megamodelling_19 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute"]])
        _initialized_behaviour_wait_for_action_megamodelling_19.setAction(self._initialized_behaviour_wait_for_action_megamodelling_19_exec)
        _initialized_behaviour_wait_for_action_megamodelling_19.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_19.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_19_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_19)
        _initialized_behaviour_wait_for_action_megamodelling_20 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/permission_modify"]])
        _initialized_behaviour_wait_for_action_megamodelling_20.setAction(self._initialized_behaviour_wait_for_action_megamodelling_20_exec)
        _initialized_behaviour_wait_for_action_megamodelling_20.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_20.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_20_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_20)
        _initialized_behaviour_wait_for_action_megamodelling_21 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/permission_owner"]])
        _initialized_behaviour_wait_for_action_megamodelling_21.setAction(self._initialized_behaviour_wait_for_action_megamodelling_21_exec)
        _initialized_behaviour_wait_for_action_megamodelling_21.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_21.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_21_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_21)
        _initialized_behaviour_wait_for_action_megamodelling_22 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/permission_group"]])
        _initialized_behaviour_wait_for_action_megamodelling_22.setAction(self._initialized_behaviour_wait_for_action_megamodelling_22_exec)
        _initialized_behaviour_wait_for_action_megamodelling_22.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_22.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_22_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_22)
        _initialized_behaviour_wait_for_action_megamodelling_23 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/group_create"]])
        _initialized_behaviour_wait_for_action_megamodelling_23.setAction(self._initialized_behaviour_wait_for_action_megamodelling_23_exec)
        _initialized_behaviour_wait_for_action_megamodelling_23.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_23.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_23_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_23)
        _initialized_behaviour_wait_for_action_megamodelling_24 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/group_delete"]])
        _initialized_behaviour_wait_for_action_megamodelling_24.setAction(self._initialized_behaviour_wait_for_action_megamodelling_24_exec)
        _initialized_behaviour_wait_for_action_megamodelling_24.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_24.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_24_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_24)
        _initialized_behaviour_wait_for_action_megamodelling_25 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/group_owner_add"]])
        _initialized_behaviour_wait_for_action_megamodelling_25.setAction(self._initialized_behaviour_wait_for_action_megamodelling_25_exec)
        _initialized_behaviour_wait_for_action_megamodelling_25.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_25.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_25_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_25)
        _initialized_behaviour_wait_for_action_megamodelling_26 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/group_owner_delete"]])
        _initialized_behaviour_wait_for_action_megamodelling_26.setAction(self._initialized_behaviour_wait_for_action_megamodelling_26_exec)
        _initialized_behaviour_wait_for_action_megamodelling_26.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_26.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_26_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_26)
        _initialized_behaviour_wait_for_action_megamodelling_27 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/group_join"]])
        _initialized_behaviour_wait_for_action_megamodelling_27.setAction(self._initialized_behaviour_wait_for_action_megamodelling_27_exec)
        _initialized_behaviour_wait_for_action_megamodelling_27.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_27.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_27_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_27)
        _initialized_behaviour_wait_for_action_megamodelling_28 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/group_kick"]])
        _initialized_behaviour_wait_for_action_megamodelling_28.setAction(self._initialized_behaviour_wait_for_action_megamodelling_28_exec)
        _initialized_behaviour_wait_for_action_megamodelling_28.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_28.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_28_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_28)
        _initialized_behaviour_wait_for_action_megamodelling_29 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/group_list"]])
        _initialized_behaviour_wait_for_action_megamodelling_29.setAction(self._initialized_behaviour_wait_for_action_megamodelling_29_exec)
        _initialized_behaviour_wait_for_action_megamodelling_29.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_29.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_29_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_29)
        _initialized_behaviour_wait_for_action_megamodelling_30 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/admin_promote"]])
        _initialized_behaviour_wait_for_action_megamodelling_30.setAction(self._initialized_behaviour_wait_for_action_megamodelling_30_exec)
        _initialized_behaviour_wait_for_action_megamodelling_30.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_30.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_30_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_30)
        _initialized_behaviour_wait_for_action_megamodelling_31 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/admin_demote"]])
        _initialized_behaviour_wait_for_action_megamodelling_31.setAction(self._initialized_behaviour_wait_for_action_megamodelling_31_exec)
        _initialized_behaviour_wait_for_action_megamodelling_31.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_31.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_31_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_31)
        _initialized_behaviour_wait_for_action_megamodelling_32 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/conformance_delete"]])
        _initialized_behaviour_wait_for_action_megamodelling_32.setAction(self._initialized_behaviour_wait_for_action_megamodelling_32_exec)
        _initialized_behaviour_wait_for_action_megamodelling_32.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_32.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_32_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_32)
        _initialized_behaviour_wait_for_action_megamodelling_33 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/conformance_add"]])
        _initialized_behaviour_wait_for_action_megamodelling_33.setAction(self._initialized_behaviour_wait_for_action_megamodelling_33_exec)
        _initialized_behaviour_wait_for_action_megamodelling_33.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_33.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_33_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_33)
        _initialized_behaviour_wait_for_action_megamodelling_34 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/folder_create"]])
        _initialized_behaviour_wait_for_action_megamodelling_34.setAction(self._initialized_behaviour_wait_for_action_megamodelling_34_exec)
        _initialized_behaviour_wait_for_action_megamodelling_34.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_34.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_34_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_34)
        _initialized_behaviour_wait_for_action_megamodelling_35 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/model_types"]])
        _initialized_behaviour_wait_for_action_megamodelling_35.setAction(self._initialized_behaviour_wait_for_action_megamodelling_35_exec)
        _initialized_behaviour_wait_for_action_megamodelling_35.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_35.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_35_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_35)
        _initialized_behaviour_wait_for_action_megamodelling_36 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/operations/service_register"]])
        _initialized_behaviour_wait_for_action_megamodelling_36.setAction(self._initialized_behaviour_wait_for_action_megamodelling_36_exec)
        _initialized_behaviour_wait_for_action_megamodelling_36.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_36.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_36_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_36)
        _initialized_behaviour_wait_for_action_megamodelling_37 = Transition(self, self.states["/initialized/behaviour/wait_for_action/megamodelling"], [self.states["/initialized/behaviour/going_manual"]])
        _initialized_behaviour_wait_for_action_megamodelling_37.setTrigger(None)
        _initialized_behaviour_wait_for_action_megamodelling_37.setGuard(self._initialized_behaviour_wait_for_action_megamodelling_37_guard)
        self.states["/initialized/behaviour/wait_for_action/megamodelling"].addTransition(_initialized_behaviour_wait_for_action_megamodelling_37)
        
        # transition /initialized/behaviour/wait_for_action/service
        _initialized_behaviour_wait_for_action_service_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action/service"], [self.states["/initialized/behaviour/wait_for_action/service"]])
        _initialized_behaviour_wait_for_action_service_0.setAction(self._initialized_behaviour_wait_for_action_service_0_exec)
        _initialized_behaviour_wait_for_action_service_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_service_0.setGuard(self._initialized_behaviour_wait_for_action_service_0_guard)
        self.states["/initialized/behaviour/wait_for_action/service"].addTransition(_initialized_behaviour_wait_for_action_service_0)
        _initialized_behaviour_wait_for_action_service_1 = Transition(self, self.states["/initialized/behaviour/wait_for_action/service"], [self.states["/initialized/behaviour/operations/service_stop"]])
        _initialized_behaviour_wait_for_action_service_1.setAction(self._initialized_behaviour_wait_for_action_service_1_exec)
        _initialized_behaviour_wait_for_action_service_1.setTrigger(None)
        _initialized_behaviour_wait_for_action_service_1.setGuard(self._initialized_behaviour_wait_for_action_service_1_guard)
        self.states["/initialized/behaviour/wait_for_action/service"].addTransition(_initialized_behaviour_wait_for_action_service_1)
        
        # transition /initialized/behaviour/wait_for_action/modelling/recognized/manual
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"], [self.states["/initialized/behaviour/leaving_manual"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_0.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_manual_0_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_manual_0)
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_1 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"], [self.states["/initialized/behaviour/leaving_manual_drop"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_1.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_1.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_manual_1_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_manual_1)
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_2 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"], [self.states["/initialized/behaviour/leaving_manual"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_2.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_manual_2.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_manual_2_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_manual_2)
        
        # transition /initialized/behaviour/wait_for_action/modelling/recognized/scripted
        _initialized_behaviour_wait_for_action_modelling_recognized_scripted_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized/scripted"], [self.states["/initialized/behaviour/operations/store_on_scripted/history"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_scripted_0.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_scripted_0_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_scripted_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_scripted_0.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_scripted_0_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized/scripted"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_scripted_0)
        _initialized_behaviour_wait_for_action_modelling_recognized_scripted_1 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized/scripted"], [self.states["/initialized/behaviour/operations/store_on_scripted/history"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_scripted_1.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_scripted_1_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_scripted_1.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_scripted_1.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_scripted_1_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized/scripted"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_scripted_1)
        
        # transition /initialized/behaviour/going_manual/init
        _initialized_behaviour_going_manual_init_0 = Transition(self, self.states["/initialized/behaviour/going_manual/init"], [self.states["/initialized/behaviour/going_manual/OK"]])
        _initialized_behaviour_going_manual_init_0.setTrigger(None)
        _initialized_behaviour_going_manual_init_0.setGuard(self._initialized_behaviour_going_manual_init_0_guard)
        self.states["/initialized/behaviour/going_manual/init"].addTransition(_initialized_behaviour_going_manual_init_0)
        _initialized_behaviour_going_manual_init_1 = Transition(self, self.states["/initialized/behaviour/going_manual/init"], [self.states["/initialized/behaviour/going_manual/search"]])
        _initialized_behaviour_going_manual_init_1.setTrigger(None)
        _initialized_behaviour_going_manual_init_1.setGuard(self._initialized_behaviour_going_manual_init_1_guard)
        self.states["/initialized/behaviour/going_manual/init"].addTransition(_initialized_behaviour_going_manual_init_1)
        
        # transition /initialized/behaviour/going_manual/search
        _initialized_behaviour_going_manual_search_0 = Transition(self, self.states["/initialized/behaviour/going_manual/search"], [self.states["/initialized/behaviour/going_manual/OK"]])
        _initialized_behaviour_going_manual_search_0.setAction(self._initialized_behaviour_going_manual_search_0_exec)
        _initialized_behaviour_going_manual_search_0.setTrigger(None)
        _initialized_behaviour_going_manual_search_0.setGuard(self._initialized_behaviour_going_manual_search_0_guard)
        self.states["/initialized/behaviour/going_manual/search"].addTransition(_initialized_behaviour_going_manual_search_0)
        
        # transition /initialized/behaviour/going_manual/OK
        _initialized_behaviour_going_manual_OK_0 = Transition(self, self.states["/initialized/behaviour/going_manual/OK"], [self.states["/initialized/behaviour/wait_for_action/modelling/recognized/manual"]])
        _initialized_behaviour_going_manual_OK_0.setTrigger(None)
        _initialized_behaviour_going_manual_OK_0.setGuard(self._initialized_behaviour_going_manual_OK_0_guard)
        self.states["/initialized/behaviour/going_manual/OK"].addTransition(_initialized_behaviour_going_manual_OK_0)
        _initialized_behaviour_going_manual_OK_1 = Transition(self, self.states["/initialized/behaviour/going_manual/OK"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_going_manual_OK_1.setAction(self._initialized_behaviour_going_manual_OK_1_exec)
        _initialized_behaviour_going_manual_OK_1.setTrigger(None)
        _initialized_behaviour_going_manual_OK_1.setGuard(self._initialized_behaviour_going_manual_OK_1_guard)
        self.states["/initialized/behaviour/going_manual/OK"].addTransition(_initialized_behaviour_going_manual_OK_1)
        
        # transition /initialized/behaviour/going_scripted
        _initialized_behaviour_going_scripted_0 = Transition(self, self.states["/initialized/behaviour/going_scripted"], [self.states["/initialized/behaviour/wait_for_action/modelling/recognized/scripted"]])
        _initialized_behaviour_going_scripted_0.setTrigger(None)
        self.states["/initialized/behaviour/going_scripted"].addTransition(_initialized_behaviour_going_scripted_0)
        
        # transition /initialized/behaviour/leaving_manual
        _initialized_behaviour_leaving_manual_0 = Transition(self, self.states["/initialized/behaviour/leaving_manual"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_leaving_manual_0.setTrigger(None)
        _initialized_behaviour_leaving_manual_0.setGuard(self._initialized_behaviour_leaving_manual_0_guard)
        self.states["/initialized/behaviour/leaving_manual"].addTransition(_initialized_behaviour_leaving_manual_0)
        
        # transition /initialized/behaviour/leaving_manual_drop
        _initialized_behaviour_leaving_manual_drop_0 = Transition(self, self.states["/initialized/behaviour/leaving_manual_drop"], [self.states["/initialized/behaviour/wait_for_action/megamodelling"]])
        _initialized_behaviour_leaving_manual_drop_0.setTrigger(None)
        _initialized_behaviour_leaving_manual_drop_0.setGuard(self._initialized_behaviour_leaving_manual_drop_0_guard)
        self.states["/initialized/behaviour/leaving_manual_drop"].addTransition(_initialized_behaviour_leaving_manual_drop_0)
        
        # transition /initialized/queue/queue
        _initialized_queue_queue_0 = Transition(self, self.states["/initialized/queue/queue"], [self.states["/initialized/queue/queue"]])
        _initialized_queue_queue_0.setAction(self._initialized_queue_queue_0_exec)
        _initialized_queue_queue_0.setTrigger(Event("action", None))
        self.states["/initialized/queue/queue"].addTransition(_initialized_queue_queue_0)
        _initialized_queue_queue_1 = Transition(self, self.states["/initialized/queue/queue"], [self.states["/initialized/queue/queue"]])
        _initialized_queue_queue_1.setAction(self._initialized_queue_queue_1_exec)
        _initialized_queue_queue_1.setTrigger(Event("result", None))
        self.states["/initialized/queue/queue"].addTransition(_initialized_queue_queue_1)
        _initialized_queue_queue_2 = Transition(self, self.states["/initialized/queue/queue"], [self.states["/initialized/queue/queue"]])
        _initialized_queue_queue_2.setAction(self._initialized_queue_queue_2_exec)
        _initialized_queue_queue_2.setTrigger(Event("data_output", None))
        self.states["/initialized/queue/queue"].addTransition(_initialized_queue_queue_2)
        _initialized_queue_queue_3 = Transition(self, self.states["/initialized/queue/queue"], [self.states["/initialized/queue/queue"]])
        _initialized_queue_queue_3.setAction(self._initialized_queue_queue_3_exec)
        _initialized_queue_queue_3.setTrigger(Event("exception", None))
        self.states["/initialized/queue/queue"].addTransition(_initialized_queue_queue_3)
        _initialized_queue_queue_4 = Transition(self, self.states["/initialized/queue/queue"], [self.states["/initialized/queue/queue"]])
        _initialized_queue_queue_4.setAction(self._initialized_queue_queue_4_exec)
        _initialized_queue_queue_4.setTrigger(Event("ready", None))
        self.states["/initialized/queue/queue"].addTransition(_initialized_queue_queue_4)
        _initialized_queue_queue_5 = Transition(self, self.states["/initialized/queue/queue"], [self.states["/initialized/queue/queue"]])
        _initialized_queue_queue_5.setAction(self._initialized_queue_queue_5_exec)
        _initialized_queue_queue_5.setTrigger(Event("data_input", None))
        self.states["/initialized/queue/queue"].addTransition(_initialized_queue_queue_5)
        
        # transition /initialized/behaviour/operations
        _initialized_behaviour_operations_0 = Transition(self, self.states["/initialized/behaviour/operations"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_0.setAction(self._initialized_behaviour_operations_0_exec)
        _initialized_behaviour_operations_0.setTrigger(None)
        _initialized_behaviour_operations_0.setGuard(self._initialized_behaviour_operations_0_guard)
        self.states["/initialized/behaviour/operations"].addTransition(_initialized_behaviour_operations_0)
        _initialized_behaviour_operations_1 = Transition(self, self.states["/initialized/behaviour/operations"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_1.setAction(self._initialized_behaviour_operations_1_exec)
        _initialized_behaviour_operations_1.setTrigger(None)
        _initialized_behaviour_operations_1.setGuard(self._initialized_behaviour_operations_1_guard)
        self.states["/initialized/behaviour/operations"].addTransition(_initialized_behaviour_operations_1)
        _initialized_behaviour_operations_2 = Transition(self, self.states["/initialized/behaviour/operations"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_2.setAction(self._initialized_behaviour_operations_2_exec)
        _initialized_behaviour_operations_2.setTrigger(None)
        _initialized_behaviour_operations_2.setGuard(self._initialized_behaviour_operations_2_guard)
        self.states["/initialized/behaviour/operations"].addTransition(_initialized_behaviour_operations_2)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_MT
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0.setAction(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0_exec)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_MT"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/transformation_add_AL
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"], [self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL/send_model"]])
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_transformation_add_AL_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/transformation_add_AL"].addTransition(_initialized_behaviour_operations_store_on_scripted_transformation_add_AL_0)
        
        # transition /initialized/behaviour/operations/store_on_scripted/process_execute/enacting
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_0 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_0.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_0.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_0_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_enacting_0)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_1 = Transition(self, self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"], [self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/executing"]])
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_1.setTrigger(None)
        _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_1.setGuard(self._initialized_behaviour_operations_store_on_scripted_process_execute_enacting_1_guard)
        self.states["/initialized/behaviour/operations/store_on_scripted/process_execute/enacting"].addTransition(_initialized_behaviour_operations_store_on_scripted_process_execute_enacting_1)
        
        # transition /initialized/behaviour/wait_for_action
        _initialized_behaviour_wait_for_action_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_wait_for_action_0.setAction(self._initialized_behaviour_wait_for_action_0_exec)
        _initialized_behaviour_wait_for_action_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_0.setGuard(self._initialized_behaviour_wait_for_action_0_guard)
        self.states["/initialized/behaviour/wait_for_action"].addTransition(_initialized_behaviour_wait_for_action_0)
        
        # transition /initialized/behaviour/wait_for_action/modelling
        _initialized_behaviour_wait_for_action_modelling_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling"], [self.states["/initialized/behaviour/wait_for_action/history"]])
        _initialized_behaviour_wait_for_action_modelling_0.setAction(self._initialized_behaviour_wait_for_action_modelling_0_exec)
        _initialized_behaviour_wait_for_action_modelling_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_0.setGuard(self._initialized_behaviour_wait_for_action_modelling_0_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling"].addTransition(_initialized_behaviour_wait_for_action_modelling_0)
        _initialized_behaviour_wait_for_action_modelling_1 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling"], [self.states["/initialized/behaviour/leaving_manual"]])
        _initialized_behaviour_wait_for_action_modelling_1.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_1.setGuard(self._initialized_behaviour_wait_for_action_modelling_1_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling"].addTransition(_initialized_behaviour_wait_for_action_modelling_1)
        
        # transition /initialized/behaviour/wait_for_action/modelling/recognized
        _initialized_behaviour_wait_for_action_modelling_recognized_0 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/element_list"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_0.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_0_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_0.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_0.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_0_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_0)
        _initialized_behaviour_wait_for_action_modelling_recognized_1 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/element_list_nice"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_1.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_1_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_1.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_1.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_1_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_1)
        _initialized_behaviour_wait_for_action_modelling_recognized_2 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/types"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_2.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_2_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_2.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_2.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_2_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_2)
        _initialized_behaviour_wait_for_action_modelling_recognized_3 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/types_full"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_3.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_3_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_3.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_3.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_3_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_3)
        _initialized_behaviour_wait_for_action_modelling_recognized_4 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/read_info"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_4.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_4_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_4.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_4.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_4_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_4)
        _initialized_behaviour_wait_for_action_modelling_recognized_5 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/read_attrs"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_5.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_5_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_5.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_5.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_5_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_5)
        _initialized_behaviour_wait_for_action_modelling_recognized_6 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/read_defined_attrs"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_6.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_6_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_6.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_6.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_6_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_6)
        _initialized_behaviour_wait_for_action_modelling_recognized_7 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/instantiate"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_7.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_7_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_7.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_7.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_7_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_7)
        _initialized_behaviour_wait_for_action_modelling_recognized_8 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/delete_element"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_8.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_8_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_8.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_8.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_8_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_8)
        _initialized_behaviour_wait_for_action_modelling_recognized_9 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/attr_assign"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_9.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_9_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_9.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_9.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_9_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_9)
        _initialized_behaviour_wait_for_action_modelling_recognized_10 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/model_upload"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_10.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_10_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_10.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_10.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_10_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_10)
        _initialized_behaviour_wait_for_action_modelling_recognized_11 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/attr_assign_code"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_11.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_11_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_11.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_11.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_11_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_11)
        _initialized_behaviour_wait_for_action_modelling_recognized_12 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/attr_delete"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_12.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_12_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_12.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_12.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_12_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_12)
        _initialized_behaviour_wait_for_action_modelling_recognized_13 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/attr_name"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_13.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_13_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_13.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_13.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_13_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_13)
        _initialized_behaviour_wait_for_action_modelling_recognized_14 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/attr_type"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_14.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_14_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_14.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_14.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_14_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_14)
        _initialized_behaviour_wait_for_action_modelling_recognized_15 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/attr_optional"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_15.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_15_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_15.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_15.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_15_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_15)
        _initialized_behaviour_wait_for_action_modelling_recognized_16 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/read_outgoing"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_16.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_16_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_16.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_16.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_16_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_16)
        _initialized_behaviour_wait_for_action_modelling_recognized_17 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/read_incoming"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_17.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_17_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_17.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_17.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_17_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_17)
        _initialized_behaviour_wait_for_action_modelling_recognized_18 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/read_association_source"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_18.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_18_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_18.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_18.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_18_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_18)
        _initialized_behaviour_wait_for_action_modelling_recognized_19 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/read_association_destination"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_19.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_19_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_19.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_19.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_19_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_19)
        _initialized_behaviour_wait_for_action_modelling_recognized_20 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/connections_between"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_20.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_20_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_20.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_20.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_20_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_20)
        _initialized_behaviour_wait_for_action_modelling_recognized_21 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/define_attribute"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_21.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_21_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_21.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_21.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_21_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_21)
        _initialized_behaviour_wait_for_action_modelling_recognized_22 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/undefine_attribute"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_22.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_22_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_22.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_22.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_22_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_22)
        _initialized_behaviour_wait_for_action_modelling_recognized_23 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/all_instances"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_23.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_23_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_23.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_23.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_23_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_23)
        _initialized_behaviour_wait_for_action_modelling_recognized_24 = Transition(self, self.states["/initialized/behaviour/wait_for_action/modelling/recognized"], [self.states["/initialized/behaviour/operations/save"]])
        _initialized_behaviour_wait_for_action_modelling_recognized_24.setAction(self._initialized_behaviour_wait_for_action_modelling_recognized_24_exec)
        _initialized_behaviour_wait_for_action_modelling_recognized_24.setTrigger(None)
        _initialized_behaviour_wait_for_action_modelling_recognized_24.setGuard(self._initialized_behaviour_wait_for_action_modelling_recognized_24_guard)
        self.states["/initialized/behaviour/wait_for_action/modelling/recognized"].addTransition(_initialized_behaviour_wait_for_action_modelling_recognized_24)
    
    def _initialized_enter(self):
        self.raiseInternalEvent(Event("ready", None, []))
    
    def _initialized_behaviour_init_enter(self):
        self.address, self.timeout = self.parameters
        self.address = self.address.rsplit(":", 1)
        self.address = (self.address[0], int(self.address[1]))
        
        self.i = 0
        self.controller.taskname = self.taskname = str(uuid.uuid4())
    
    def _initialized_behaviour_operations_verify_enter(self):
        self.raiseInternalEvent(Event("request", None, [['verify', self.parameters[0], self.parameters[1]]]))
    
    def _init_enter(self):
        self.big_step.outputEventOM(Event("create_instance", None, [self, 'http_client', 'HTTPClient']))
        self.big_step.outputEventOM(Event("create_instance", None, [self, 'http_client', 'HTTPClient']))
    
    def _initialized_behaviour_operations_model_list_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_list', self.parameters[0]]]))
    
    def _initialized_behaviour_operations_model_add_send_metadata_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_add', self.parameters[1], self.parameters[0], self.parameters[2]]]))
    
    def _initialized_behaviour_operations_model_delete_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_delete', self.parameters[0]]]))
    
    def _initialized_behaviour_operations_model_list_full_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_list_full', self.parameters[0]]]))
    
    def _initialized_behaviour_operations_model_upload_send_metadata_enter(self):
        self.raiseInternalEvent(Event("request", None, [['upload']]))
    
    def _initialized_behaviour_operations_model_upload_send_model_enter(self):
        self.raiseInternalEvent(Event("request", None, [self.parameters[1]]))
    
    def _initialized_behaviour_operations_model_overwrite_send_metadata_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_overwrite', self.parameters[0], self.registered_metamodel[self.parameters[0]]]]))
    
    def _initialized_behaviour_operations_model_overwrite_send_model_enter(self):
        self.raiseInternalEvent(Event("request", None, [self.parameters[1]]))
    
    def _initialized_behaviour_operations_disconnect_enter(self):
        self.raiseInternalEvent(Event("request", None, ['exit']))
    
    def _initialized_behaviour_operations_user_logout_enter(self):
        self.raiseInternalEvent(Event("request", None, ['user_logout']))
    
    def _initialized_behaviour_operations_user_delete_enter(self):
        self.raiseInternalEvent(Event("request", None, ['self-destruct']))
    
    def _initialized_behaviour_operations_model_render_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_render', self.parameters[0], self.parameters[1], self.parameters[2]]]))
    
    def _initialized_behaviour_operations_model_rendered_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_rendered', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_transformation_between_enter(self):
        self.raiseInternalEvent(Event("request", None, [['transformation_between'] + self.dict_to_list(self.parameters[0]) + self.dict_to_list(self.parameters[1])]))
    
    def _initialized_behaviour_operations_transformation_signature_enter(self):
        self.raiseInternalEvent(Event("request", None, [['transformation_read_signature', self.parameters[0]]]))
    
    def _initialized_behaviour_operations_process_signature_enter(self):
        self.raiseInternalEvent(Event("request", None, [['process_signature', self.parameters[0]]]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_enter(self):
        self.raiseInternalEvent(Event("request", None, [['transformation_add_MT'] + self.dict_to_list(self.parameters[0]) + self.dict_to_list(self.parameters[1]) + [self.parameters[2]]]))
        self.context = str(uuid.uuid4())
        self.actions[self.context] = []
        self.code = self.parameters[3]
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_enter(self):
        self.raiseInternalEvent(Event("request", None, [self.code]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_enter(self):
        self.raiseInternalEvent(Event("request", None, [['transformation_add_AL'] + self.dict_to_list(self.parameters[0]) + self.dict_to_list(self.parameters[1]) + [self.parameters[2]]]))
        self.context = str(uuid.uuid4())
        self.actions[self.context] = []
        self.code = self.parameters[3]
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_enter(self):
        self.raiseInternalEvent(Event("request", None, [self.code]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_enter(self):
        self.raiseInternalEvent(Event("request", None, [['transformation_add_MANUAL'] + self.dict_to_list(self.parameters[0]) + self.dict_to_list(self.parameters[1]) + [self.parameters[2]]]))
        self.context = str(uuid.uuid4())
        self.actions[self.context] = []
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_enter(self):
        self.raiseInternalEvent(Event("request", None, [['transformation_execute', self.parameters[0]] + self.dict_to_list(self.parameters[1]) + self.dict_to_list(self.parameters[2]) + [self.parameters[3]]]))
        if len(self.parameters) > 4 and self.parameters[4] == False:
            self.finish_output_thread = True
        print("Executing transformation " + str(self.parameters[0]))
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_init_enter(self):
        self.raiseInternalEvent(Event("request", None, [['process_execute', self.parameters[0]] + self.dict_to_list(self.parameters[1])]))
    
    def _initialized_behaviour_operations_permission_modify_enter(self):
        self.raiseInternalEvent(Event("request", None, [['permission_modify', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_permission_owner_enter(self):
        self.raiseInternalEvent(Event("request", None, [['permission_owner', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_permission_group_enter(self):
        self.raiseInternalEvent(Event("request", None, [['permission_group', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_group_create_enter(self):
        self.raiseInternalEvent(Event("request", None, [['group_create', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_group_delete_enter(self):
        self.raiseInternalEvent(Event("request", None, [['group_delete', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_group_owner_add_enter(self):
        self.raiseInternalEvent(Event("request", None, [['group_owner_add', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_group_owner_delete_enter(self):
        self.raiseInternalEvent(Event("request", None, [['group_owner_delete', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_group_join_enter(self):
        self.raiseInternalEvent(Event("request", None, [['group_join', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_group_kick_enter(self):
        self.raiseInternalEvent(Event("request", None, [['group_kick', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_group_list_enter(self):
        self.raiseInternalEvent(Event("request", None, [['group_list', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_admin_promote_enter(self):
        self.raiseInternalEvent(Event("request", None, [['admin_promote', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_admin_demote_enter(self):
        self.raiseInternalEvent(Event("request", None, [['admin_demote', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_conformance_delete_enter(self):
        self.raiseInternalEvent(Event("request", None, [['remove_conformance', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_conformance_add_enter(self):
        self.raiseInternalEvent(Event("request", None, [['add_conformance', self.parameters[0], self.parameters[1]]]))
    
    def _initialized_behaviour_operations_folder_create_enter(self):
        self.raiseInternalEvent(Event("request", None, [['folder_create', self.parameters[0]]]))
    
    def _initialized_behaviour_operations_model_types_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_types', self.parameters[0]]]))
    
    def _initialized_behaviour_operations_element_list_enter(self):
        self.raiseInternalEvent(Event("request", None, [['list_full']]))
    
    def _initialized_behaviour_operations_element_list_nice_enter(self):
        self.raiseInternalEvent(Event("request", None, [['JSON']]))
    
    def _initialized_behaviour_operations_types_enter(self):
        self.raiseInternalEvent(Event("request", None, [['types']]))
    
    def _initialized_behaviour_operations_types_full_enter(self):
        self.raiseInternalEvent(Event("request", None, [['types_full']]))
    
    def _initialized_behaviour_operations_read_info_enter(self):
        self.raiseInternalEvent(Event("request", None, [['read_info', self.parameters[1]]]))
    
    def _initialized_behaviour_operations_read_attrs_enter(self):
        self.raiseInternalEvent(Event("request", None, [['read_attrs', self.parameters[1]]]))
    
    def _initialized_behaviour_operations_read_defined_attrs_enter(self):
        self.raiseInternalEvent(Event("request", None, [['read_defined_attrs', self.parameters[1]]]))
    
    def _initialized_behaviour_operations_delete_element_enter(self):
        self.raiseInternalEvent(Event("request", None, [['delete', self.parameters[1]]]))
    
    def _initialized_behaviour_operations_attr_assign_enter(self):
        self.raiseInternalEvent(Event("request", None, [['attr_add', self.parameters[1], self.parameters[2], self.parameters[3]]]))
    
    def _initialized_behaviour_operations_attr_assign_code_enter(self):
        self.raiseInternalEvent(Event("request", None, [['attr_add_code', self.parameters[1], self.parameters[2], self.parameters[3]]]))
    
    def _initialized_behaviour_operations_attr_delete_enter(self):
        self.raiseInternalEvent(Event("request", None, [['attr_delete', self.parameters[1], self.parameters[2]]]))
    
    def _initialized_behaviour_operations_attr_type_enter(self):
        self.raiseInternalEvent(Event("request", None, [['attr_type', self.parameters[1], self.parameters[2], self.parameters[3]]]))
    
    def _initialized_behaviour_operations_attr_name_enter(self):
        self.raiseInternalEvent(Event("request", None, [['attr_name', self.parameters[1], self.parameters[2], self.parameters[3]]]))
    
    def _initialized_behaviour_operations_attr_optional_enter(self):
        self.raiseInternalEvent(Event("request", None, [['attr_optional', self.parameters[1], self.parameters[2], self.parameters[3]]]))
    
    def _initialized_behaviour_operations_read_outgoing_enter(self):
        self.raiseInternalEvent(Event("request", None, [['read_outgoing', self.parameters[1], self.parameters[2]]]))
    
    def _initialized_behaviour_operations_read_incoming_enter(self):
        self.raiseInternalEvent(Event("request", None, [['read_incoming', self.parameters[1], self.parameters[2]]]))
    
    def _initialized_behaviour_operations_read_association_source_enter(self):
        self.raiseInternalEvent(Event("request", None, [['read_association_source', self.parameters[1]]]))
    
    def _initialized_behaviour_operations_read_association_destination_enter(self):
        self.raiseInternalEvent(Event("request", None, [['read_association_destination', self.parameters[1]]]))
    
    def _initialized_behaviour_operations_connections_between_enter(self):
        self.raiseInternalEvent(Event("request", None, [['connections_between', self.parameters[1], self.parameters[2]]]))
    
    def _initialized_behaviour_operations_define_attribute_enter(self):
        self.raiseInternalEvent(Event("request", None, [['define_attribute', self.parameters[1], self.parameters[2], self.parameters[3]]]))
    
    def _initialized_behaviour_operations_undefine_attribute_enter(self):
        self.raiseInternalEvent(Event("request", None, [['undefine_attribute', self.parameters[1], self.parameters[2]]]))
    
    def _initialized_behaviour_operations_all_instances_enter(self):
        self.raiseInternalEvent(Event("request", None, [['all_instances', self.parameters[1]]]))
    
    def _initialized_behaviour_operations_save_enter(self):
        self.raiseInternalEvent(Event("request", None, [['exit', 'model_modify', self.current_model]]))
    
    def _initialized_behaviour_operations_service_register_enter(self):
        self.raiseInternalEvent(Event("request", None, [['service_register', self.parameters[0]]]))
        self.service_function = self.parameters[1]
    
    def _initialized_behaviour_operations_service_stop_enter(self):
        self.raiseInternalEvent(Event("request", None, [['service_stop']]))
    
    def _initialized_behaviour_going_manual_init_enter(self):
        self.context = None
        self.current_model = self.actions[None][0]["parameters"][0]
    
    def _initialized_behaviour_going_manual_search_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_types', self.current_model]]))
    
    def _initialized_behaviour_going_manual_OK_enter(self):
        self.raiseInternalEvent(Event("request", None, [['model_modify', self.current_model, self.registered_metamodel[self.current_model]]]))
    
    def _initialized_behaviour_going_scripted_enter(self):
        self.current_model = None
    
    def _initialized_behaviour_leaving_manual_enter(self):
        self.raiseInternalEvent(Event("request", None, ['exit']))
    
    def _initialized_behaviour_leaving_manual_drop_enter(self):
        self.raiseInternalEvent(Event("request", None, ['drop']))
    
    def _initialized_behaviour_operations_0_exec(self, parameters):
        self.raiseInternalEvent(Event("exception", None, ['UnknownIdentifier', 'Element could not be found']))
        self.responses.pop(0)
    
    def _initialized_behaviour_operations_0_guard(self, parameters):
        return self.expect_response_partial('Element not found: ', pop=False)
    
    def _initialized_behaviour_operations_1_exec(self, parameters):
        self.raiseInternalEvent(Event("exception", None, ['UnknownMetamodellingHierarchy', 'Conformance relation not found']))
        self.responses.pop(0)
    
    def _initialized_behaviour_operations_1_guard(self, parameters):
        return self.expect_response_partial('No conformance relation can be found ', pop=False)
    
    def _initialized_behaviour_operations_2_exec(self, parameters):
        #print("Unknown Error: " + self.responses[0])
        pass
        self.raiseInternalEvent(Event("exception", None, ['UnknownError', 'Error: %s' % self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_2_guard(self, parameters):
        return self.expect_response_partial('', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0_exec(self, parameters):
        print("UNKNOWN RESPONSE received: " + str(self.responses.pop(0)))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_0_guard(self, parameters):
        return self.expect_response_partial('', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_0_guard(self, parameters):
        return self.expect_response('Waiting for code constructors...')
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_0_guard(self, parameters):
        return self.expect_response('Success', pop=True)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_1_guard(self, parameters):
        return self.expect_response('Failure', pop=True)
    
    def _initialized_behaviour_wait_for_action_0_exec(self, parameters):
        print("Got unknown operation: " + str(self.actions[None].pop(0)))
        self.raiseInternalEvent(Event("exception", None, ['UnknownOperation', 'Operation is unknown']))
    
    def _initialized_behaviour_wait_for_action_0_guard(self, parameters):
        return self.context is None and self.actions[None]
    
    def _initialized_behaviour_wait_for_action_modelling_0_exec(self, parameters):
        print("Got unexpected operation: " + str(self.actions[self.context].pop(0)))
        self.raiseInternalEvent(Event("exception", None, ['IllegalContextOperation', 'Operation not allowed in a context!']))
    
    def _initialized_behaviour_wait_for_action_modelling_0_guard(self, parameters):
        return self.context is not None and self.actions[self.context]
    
    def _initialized_behaviour_wait_for_action_modelling_1_guard(self, parameters):
        return self.context is None and self.actions[None]
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_0_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_0_guard(self, parameters):
        return self.expect_action(self.context, 'element_list')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_1_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_1_guard(self, parameters):
        return self.expect_action(self.context, 'element_list_nice')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_2_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_2_guard(self, parameters):
        return self.expect_action(self.context, 'types')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_3_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_3_guard(self, parameters):
        return self.expect_action(self.context, 'types_full')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_4_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_4_guard(self, parameters):
        return self.expect_action(self.context, 'read_info')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_5_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_5_guard(self, parameters):
        return self.expect_action(self.context, 'read_attrs')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_6_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_6_guard(self, parameters):
        return self.expect_action(self.context, 'read_defined_attrs')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_7_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_7_guard(self, parameters):
        return self.expect_action(self.context, 'instantiate')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_8_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_8_guard(self, parameters):
        return self.expect_action(self.context, 'delete_element')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_9_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_9_guard(self, parameters):
        return self.expect_action(self.context, 'attr_assign')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_10_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_10_guard(self, parameters):
        return self.expect_action(self.context, 'model_overwrite')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_11_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_11_guard(self, parameters):
        return self.expect_action(self.context, 'attr_assign_code')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_12_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_12_guard(self, parameters):
        return self.expect_action(self.context, 'attr_delete')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_13_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_13_guard(self, parameters):
        return self.expect_action(self.context, 'attr_name')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_14_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_14_guard(self, parameters):
        return self.expect_action(self.context, 'attr_type')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_15_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_15_guard(self, parameters):
        return self.expect_action(self.context, 'attr_optional')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_16_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_16_guard(self, parameters):
        return self.expect_action(self.context, 'read_outgoing')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_17_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_17_guard(self, parameters):
        return self.expect_action(self.context, 'read_incoming')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_18_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_18_guard(self, parameters):
        return self.expect_action(self.context, 'read_association_source')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_19_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_19_guard(self, parameters):
        return self.expect_action(self.context, 'read_association_destination')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_20_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_20_guard(self, parameters):
        return self.expect_action(self.context, 'connections_between')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_21_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_21_guard(self, parameters):
        return self.expect_action(self.context, 'define_attribute')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_22_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_22_guard(self, parameters):
        return self.expect_action(self.context, 'undefine_attribute')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_23_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_23_guard(self, parameters):
        return self.expect_action(self.context, 'all_instances')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_24_exec(self, parameters):
        self.load_action(self.context)
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_24_guard(self, parameters):
        return self.expect_action(self.context, 'save')
    
    def _init_0_exec(self, parameters):
        instance = parameters[0]
        self.http_clients.append(instance)
        self.big_step.outputEventOM(Event("start_instance", None, [self, instance]))
    
    def _init_1_guard(self, parameters):
        return len(self.http_clients) == 2
    
    def _initialized_http_mapper_init_0_exec(self, parameters):
        value = parameters[0]
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, self.http_clients[0], Event("HTTP_input", None, [urllib.urlencode({"op": "set_input", "data": json.dumps(value), "taskname": self.taskname}), None])]))
    
    def _initialized_http_mapper_init_0_guard(self, parameters):
        value = parameters[0]
        return isinstance(value, type([]))
    
    def _initialized_http_mapper_init_1_exec(self, parameters):
        value = parameters[0]
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, self.http_clients[0], Event("HTTP_input", None, [urllib.urlencode({"op": "set_input", "value": json.dumps(value), "taskname": self.taskname}), None])]))
    
    def _initialized_http_mapper_init_1_guard(self, parameters):
        value = parameters[0]
        return not isinstance(value, type([]))
    
    def _initialized_http_mapper_init_2_exec(self, parameters):
        value = parameters[0]
        taskname = parameters[1]
        http_client = parameters[2]
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, self.http_clients[http_client], Event("HTTP_input", None, [urllib.urlencode({"op": "set_input", "value": json.dumps(value), "taskname": taskname}), "parent"])]))
    
    def _initialized_http_mapper_init_3_exec(self, parameters):
        data = parameters[0]
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, self.http_clients[1], Event("HTTP_input", None, [urllib.urlencode({"op": "get_output", "taskname": self.taskname}), "parent"])]))
        self.responses.append(json.loads(data))
        print("Got data: " + str(json.loads(data)))
    
    def _initialized_http_mapper_init_3_guard(self, parameters):
        data = parameters[0]
        return not self.finish_output_thread
    
    def _initialized_http_mapper_init_4_exec(self, parameters):
        data = parameters[0]
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, self.http_clients[1], Event("HTTP_input", None, [urllib.urlencode({"op": "get_output", "taskname": self.taskname}), "parent"])]))
        self.responses.append(json.loads(data))
    
    def _initialized_http_mapper_init_4_guard(self, parameters):
        data = parameters[0]
        return self.finish_output_thread
    
    def _initialized_behaviour_init_connect_http_client_0_exec(self, parameters):
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, self.http_clients[self.i], Event("connect", None, [self.address, self.timeout])]))
    
    def _initialized_behaviour_init_connect_http_client_0_guard(self, parameters):
        return self.i < 2
    
    def _initialized_behaviour_init_connect_http_client_1_exec(self, parameters):
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, self.http_clients[1], Event("HTTP_input", None, [urllib.urlencode({"op": "get_output", "taskname": self.taskname}), "parent"])]))
        self.raiseInternalEvent(Event("result", None, [[]]))
    
    def _initialized_behaviour_init_connect_http_client_1_guard(self, parameters):
        return self.i == 2
    
    def _initialized_behaviour_init_waiting_http_client_0_exec(self, parameters):
        self.raiseInternalEvent(Event("request_raw", None, [self.taskname, 'task_manager', self.i]))
        self.i += 1
    
    def _initialized_behaviour_init_waiting_http_client_1_exec(self, parameters):
        self.raiseInternalEvent(Event("exception", None, ['NetworkException', 'Connection timeout']))
    
    def _initialized_behaviour_init_wait_for_taskname_ack_0_guard(self, parameters):
        return self.expect_response('OK', pop=True)
    
    def _initialized_behaviour_operations_login_wait_prompt_1_0_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, [self.parameters[0]]))
    
    def _initialized_behaviour_operations_login_wait_prompt_1_0_guard(self, parameters):
        return self.expect_response('Log on as which user?', pop=True)
    
    def _initialized_behaviour_operations_login_wait_prompt_2_0_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, [self.parameters[1]]))
    
    def _initialized_behaviour_operations_login_wait_prompt_2_0_guard(self, parameters):
        return self.expect_response('Password for existing user?', pop=True)
    
    def _initialized_behaviour_operations_login_wait_prompt_2_1_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, [self.parameters[1]]))
    
    def _initialized_behaviour_operations_login_wait_prompt_2_1_guard(self, parameters):
        return self.expect_response('This is a new user: please give password!', pop=True)
    
    def _initialized_behaviour_operations_login_wait_prompt_existing_0_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, [self.parameters[1]]))
    
    def _initialized_behaviour_operations_login_wait_prompt_existing_0_guard(self, parameters):
        return self.expect_response('Please repeat the password', pop=True)
    
    def _initialized_behaviour_operations_login_wait_prompt_existing_1_guard(self, parameters):
        return self.expect_response('Passwords match!', pop=True)
    
    def _initialized_behaviour_operations_login_wait_prompt_existing_2_guard(self, parameters):
        return self.expect_response('Welcome to the Model Management Interface v2.0!', pop=True)
    
    def _initialized_behaviour_operations_login_wait_prompt_existing_3_exec(self, parameters):
        self.raiseInternalEvent(Event("exception", None, ['PermissionDenied', 'Permission denied!']))
    
    def _initialized_behaviour_operations_login_wait_prompt_existing_3_guard(self, parameters):
        return self.expect_response('Wrong password!', pop=True)
    
    def _initialized_behaviour_operations_login_login_ok_0_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, ['quiet']))
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_login_login_ok_0_guard(self, parameters):
        return self.expect_response('Use the \'help\' command for a list of possible commands', pop=True)
    
    def _initialized_behaviour_operations_model_list_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_model_list_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_model_add_send_metadata_0_exec(self, parameters):
        self.registered_metamodel[self.parameters[0]] = self.parameters[1]
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_model_add_send_metadata_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_model_delete_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_model_delete_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_model_list_full_0_exec(self, parameters):
        response = self.split_response(self.responses.pop(0))
        result = set()
        for res in response:
            i = res.split(" ", 3)
            result.add((i[3], i[1], i[2], i[0]))
        self.raiseInternalEvent(Event("result", None, [result]))
    
    def _initialized_behaviour_operations_model_list_full_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_verify_waiting_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.split_response(self.responses.pop(0))[0]]))
    
    def _initialized_behaviour_operations_verify_waiting_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_alter_context_0_exec(self, parameters):
        self.registered_metamodel[self.parameters[0]] = self.parameters[1]
    
    def _initialized_behaviour_operations_model_upload_send_metadata_0_guard(self, parameters):
        return self.expect_response('Waiting for model constructors...')
    
    def _initialized_behaviour_operations_model_upload_send_model_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_model_upload_send_model_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_model_overwrite_send_metadata_0_guard(self, parameters):
        return self.expect_response('Waiting for model constructors...')
    
    def _initialized_behaviour_operations_model_overwrite_send_model_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_model_overwrite_send_model_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_disconnect_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_disconnect_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_user_logout_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_user_logout_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_user_delete_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_user_delete_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_model_render_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [json.loads(self.split_response(self.responses.pop(0))[0])]))
    
    def _initialized_behaviour_operations_model_render_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_model_rendered_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_model_rendered_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_transformation_between_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_transformation_between_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_transformation_signature_0_exec(self, parameters):
        results = self.split_response(self.responses.pop(0))
        inputs = {}
        outputs = {}
        for result in results:
            key, value = result[1:].strip().split(" ", 1)
            if result[0] == "I":
                inputs[key] = value
            elif result[0] == "O":
                outputs[key] = value
        self.raiseInternalEvent(Event("result", None, [(inputs, outputs)]))
    
    def _initialized_behaviour_operations_transformation_signature_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_process_signature_0_exec(self, parameters):
        results = self.split_response(self.responses.pop(0))
        signature = {}
        for result in results:
            key, value = result.strip().split(" : ", 1)
            signature[key] = value
        self.raiseInternalEvent(Event("result", None, [signature]))
    
    def _initialized_behaviour_operations_process_signature_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [[self.context, self.responses.pop(0).split(': ', 1)[1]]]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_metadata_0_guard(self, parameters):
        return self.expect_response_partial('Operating on: ')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_0_guard(self, parameters):
        return self.expect_response('Model loaded, ready for commands!')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_edit_metamodel_1_guard(self, parameters):
        return self.expect_response('Waiting for model constructors...')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MT_send_model_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [[self.context, self.responses.pop(0).split(': ', 1)[1]]]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_metadata_0_guard(self, parameters):
        return self.expect_response_partial('Operating on: ')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_edit_metamodel_0_guard(self, parameters):
        return self.expect_response('Model loaded, ready for commands!')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_AL_send_model_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [[self.context, self.responses.pop(0).split(': ', 1)[1]]]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_send_metadata_0_guard(self, parameters):
        return self.expect_response_partial('Operating on: ')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_0_guard(self, parameters):
        return self.expect_response('Model loaded, ready for commands!')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_add_MANUAL_edit_metamodel_1_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0_exec(self, parameters):
        self.context = str(uuid.uuid4())
        self.actions[self.context] = []
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_0_guard(self, parameters):
        return self.expect_response('Success: ready for MANUAL execution', pop=True)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1_exec(self, parameters):
        self.input_context = str(uuid.uuid4())
        self.inputs[self.input_context] = []
        self.raiseInternalEvent(Event("result", None, [['SC', self.parameters[0], self.input_context]]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_send_operation_1_guard(self, parameters):
        return self.expect_response('Success: ready for AL execution', pop=True) or self.expect_response('Success: ready for MT execution', pop=True)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [True if self.responses.pop(0) == 'Success' else False]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_0_guard(self, parameters):
        return self.expect_response('Success', pop=False) or self.expect_response('Failure', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1_exec(self, parameters):
        self.raiseInternalEvent(Event("data_output", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_1_guard(self, parameters):
        return not (self.expect_response('Success', pop=False) or self.expect_response('Failure', pop=False)) and self.expect_response_partial('', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, [self.inputs[self.input_context].pop(0)['parameters']]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_dialog_2_guard(self, parameters):
        return self.expect_input(self.input_context, 'data_input')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_0_guard(self, parameters):
        return self.expect_response_partial('Please perform manual operation ', pop=True)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1_exec(self, parameters):
        model = self.responses.pop(0).split(": ", 1)[1]
        self.raiseInternalEvent(Event("result", None, [['OP', self.parameters[0], self.context, model]]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_1_guard(self, parameters):
        return self.expect_response_partial('Operating on: ', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_2_guard(self, parameters):
        return self.expect_response('Model loaded, ready for commands!')
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [True]))
    
    def _initialized_behaviour_operations_store_on_scripted_transformation_execute_edit_model_3_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_init_0_guard(self, parameters):
        return self.expect_response('Success', pop=True)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_executing_0_exec(self, parameters):
        self.op_name = self.responses.pop(0).split(": ", 1)[1]
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_executing_0_guard(self, parameters):
        return self.expect_response_partial('Enacting ModelTransformation', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_executing_1_exec(self, parameters):
        self.op_name = self.responses.pop(0).split(": ", 1)[1]
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_executing_1_guard(self, parameters):
        return self.expect_response_partial('Enacting ActionLanguage', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_executing_2_exec(self, parameters):
        self.op_name = self.responses.pop(0).split(": ", 1)[1]
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_executing_2_guard(self, parameters):
        return self.expect_response_partial('Enacting ManualOperation', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_executing_3_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, ['Finished']))
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_executing_3_guard(self, parameters):
        return self.expect_response('Success', pop=True)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_init_0_exec(self, parameters):
        self.input_context = str(uuid.uuid4())
        self.inputs[self.input_context] = []
        self.raiseInternalEvent(Event("result", None, [['SC', self.op_name, self.input_context]]))
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0_exec(self, parameters):
        self.raiseInternalEvent(Event("data_output", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_0_guard(self, parameters):
        return not (self.expect_response('Success', pop=False) or self.expect_response('Failure', pop=False)) and self.expect_response_partial('', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, [self.inputs[self.input_context].pop(0)['parameters']]))
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_sc_processing_1_guard(self, parameters):
        return self.expect_input(self.input_context, 'data_input')
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_0_guard(self, parameters):
        return self.expect_response_partial('Please perform manual operation ', pop=True)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1_exec(self, parameters):
        model = self.responses.pop(0).split(": ", 1)[1]
        self.context = str(uuid.uuid4())
        self.actions[self.context] = []
        self.raiseInternalEvent(Event("result", None, [['OP', self.op_name, self.context, model]]))
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_1_guard(self, parameters):
        return self.expect_response_partial('Operating on: ', pop=False)
    
    def _initialized_behaviour_operations_store_on_scripted_process_execute_enacting_op_2_guard(self, parameters):
        return self.expect_response('Model loaded, ready for commands!')
    
    def _initialized_behaviour_operations_permission_modify_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_permission_modify_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_permission_owner_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_permission_owner_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_permission_group_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_permission_group_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_group_create_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_group_create_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_group_delete_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_group_delete_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_group_owner_add_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_group_owner_add_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_group_owner_delete_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_group_owner_delete_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_group_join_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_group_join_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_group_kick_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_group_kick_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_group_list_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_group_list_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_admin_promote_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_admin_promote_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_admin_demote_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.responses.pop(0)]))
    
    def _initialized_behaviour_operations_admin_demote_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_conformance_delete_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_conformance_delete_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_conformance_add_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_conformance_add_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_folder_create_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_folder_create_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_model_types_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_model_types_0_guard(self, parameters):
        return self.expect_response_partial('Success: ')
    
    def _initialized_behaviour_operations_element_list_0_exec(self, parameters):
        responses = self.split_response(self.responses.pop(0))
        result = set([tuple([j.strip() for j in i.split(':')]) for i in responses])
        self.raiseInternalEvent(Event("result", None, [result]))
    
    def _initialized_behaviour_operations_element_list_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_element_list_nice_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [json.loads(self.split_response(self.responses.pop(0))[0])]))
    
    def _initialized_behaviour_operations_element_list_nice_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_types_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set([tuple(entry.strip().split(' : ')) for entry in self.split_response(self.responses.pop(0))])]))
    
    def _initialized_behaviour_operations_types_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_types_full_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set([tuple(entry.strip().split(' : ')) for entry in self.split_response(self.responses.pop(0))])]))
    
    def _initialized_behaviour_operations_types_full_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_read_info_0_exec(self, parameters):
        response = self.responses.pop(0).split(": ", 1)[1].strip()
        values = {line.split(": ", 1)[0]: line.split(": ", 1)[1] for line in response.split("\n", 2)}
        if "Source" in values:
            result = (values["Type"], (values["Source"], values["Destination"]))
        else:
            result = (values["Type"], None)
        self.raiseInternalEvent(Event("result", None, [result]))
    
    def _initialized_behaviour_operations_read_info_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_read_attrs_0_exec(self, parameters):
        response = self.responses.pop(0).split(": ", 1)[1].strip()
        values = {line.split(" : ", 1)[0]: line.split(" : ", 1)[1] for line in response.split("\n")}
        values = {key: values[key].split(" = ", 1)[1] for key in values}
        self.raiseInternalEvent(Event("result", None, [values]))
    
    def _initialized_behaviour_operations_read_attrs_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_read_defined_attrs_0_exec(self, parameters):
        response = self.responses.pop(0).split(": ", 1)[1].strip()
        value_mandatory = {line.split(" : ", 1)[0]: line.split(" : ", 1)[1] for line in response.split("\n") if " : " in line}
        value_optional = {line.split(" ?: ", 1)[0]: line.split(" ?: ", 1)[1] for line in response.split("\n") if " ?: " in line}
        self.raiseInternalEvent(Event("result", None, [(value_mandatory, value_optional)]))
    
    def _initialized_behaviour_operations_read_defined_attrs_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_instantiate_decide_node_or_edge_0_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, [['instantiate_node', self.parameters[1], self.parameters[3]]]))
    
    def _initialized_behaviour_operations_instantiate_decide_node_or_edge_0_guard(self, parameters):
        return self.parameters[2] is None
    
    def _initialized_behaviour_operations_instantiate_decide_node_or_edge_1_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, [['instantiate_edge', self.parameters[1], self.parameters[3], self.parameters[2][0], self.parameters[2][1]]]))
    
    def _initialized_behaviour_operations_instantiate_decide_node_or_edge_1_guard(self, parameters):
        return self.parameters[2] is not None
    
    def _initialized_behaviour_operations_instantiate_created_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.split_response(self.responses.pop(0))[0]]))
    
    def _initialized_behaviour_operations_instantiate_created_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_delete_element_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_delete_element_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_attr_assign_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_attr_assign_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_attr_assign_code_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_attr_assign_code_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_attr_delete_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_attr_delete_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_attr_type_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_attr_type_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_attr_name_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_attr_name_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_attr_optional_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_attr_optional_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_read_outgoing_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_read_outgoing_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_read_incoming_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_read_incoming_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_read_association_source_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.split_response(self.responses.pop(0))]))
    
    def _initialized_behaviour_operations_read_association_source_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_read_association_destination_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [self.split_response(self.responses.pop(0))]))
    
    def _initialized_behaviour_operations_read_association_destination_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_connections_between_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_connections_between_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_define_attribute_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_define_attribute_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_undefine_attribute_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [None]))
    
    def _initialized_behaviour_operations_undefine_attribute_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_all_instances_0_exec(self, parameters):
        self.raiseInternalEvent(Event("result", None, [set(self.split_response(self.responses.pop(0)))]))
    
    def _initialized_behaviour_operations_all_instances_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_save_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_operations_save_1_guard(self, parameters):
        return self.expect_response('Model loaded, ready for commands!')
    
    def _initialized_behaviour_operations_service_register_0_exec(self, parameters):
        port = self.split_response(self.responses.pop(0))[0]
        self.raiseInternalEvent(Event("result", None, [port]))
    
    def _initialized_behaviour_operations_service_register_0_guard(self, parameters):
        return self.expect_response_partial('Success: ', pop=False)
    
    def _initialized_behaviour_operations_service_stop_0_guard(self, parameters):
        return self.expect_response('Success')
    
    def _initialized_behaviour_wait_for_action_disconnected_0_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_disconnected_0_guard(self, parameters):
        return self.expect_action(None, 'init')
    
    def _initialized_behaviour_wait_for_action_connected_0_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_connected_0_guard(self, parameters):
        return self.expect_action(None, 'login')
    
    def _initialized_behaviour_wait_for_action_megamodelling_0_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_0_guard(self, parameters):
        return self.expect_action(None, 'model_list')
    
    def _initialized_behaviour_wait_for_action_megamodelling_1_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_1_guard(self, parameters):
        return self.expect_action(None, 'model_add')
    
    def _initialized_behaviour_wait_for_action_megamodelling_2_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_2_guard(self, parameters):
        return self.expect_action(None, 'model_delete')
    
    def _initialized_behaviour_wait_for_action_megamodelling_3_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_3_guard(self, parameters):
        return self.expect_action(None, 'model_list_full')
    
    def _initialized_behaviour_wait_for_action_megamodelling_4_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_4_guard(self, parameters):
        return self.expect_action(None, 'verify')
    
    def _initialized_behaviour_wait_for_action_megamodelling_5_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_5_guard(self, parameters):
        return self.expect_action(None, 'alter_context')
    
    def _initialized_behaviour_wait_for_action_megamodelling_6_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_6_guard(self, parameters):
        return self.expect_action(None, 'model_overwrite')
    
    def _initialized_behaviour_wait_for_action_megamodelling_7_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_7_guard(self, parameters):
        return self.expect_action(None, 'disconnect')
    
    def _initialized_behaviour_wait_for_action_megamodelling_8_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_8_guard(self, parameters):
        return self.expect_action(None, 'user_logout')
    
    def _initialized_behaviour_wait_for_action_megamodelling_9_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_9_guard(self, parameters):
        return self.expect_action(None, 'user_delete')
    
    def _initialized_behaviour_wait_for_action_megamodelling_10_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_10_guard(self, parameters):
        return self.expect_action(None, 'model_render')
    
    def _initialized_behaviour_wait_for_action_megamodelling_11_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_11_guard(self, parameters):
        return self.expect_action(None, 'model_rendered')
    
    def _initialized_behaviour_wait_for_action_megamodelling_12_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_12_guard(self, parameters):
        return self.expect_action(None, 'transformation_between')
    
    def _initialized_behaviour_wait_for_action_megamodelling_13_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_13_guard(self, parameters):
        return self.expect_action(None, 'transformation_signature')
    
    def _initialized_behaviour_wait_for_action_megamodelling_14_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_14_guard(self, parameters):
        return self.expect_action(None, 'process_signature')
    
    def _initialized_behaviour_wait_for_action_megamodelling_15_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_15_guard(self, parameters):
        return self.expect_action(None, 'transformation_add_MT')
    
    def _initialized_behaviour_wait_for_action_megamodelling_16_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_16_guard(self, parameters):
        return self.expect_action(None, 'transformation_add_AL')
    
    def _initialized_behaviour_wait_for_action_megamodelling_17_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_17_guard(self, parameters):
        return self.expect_action(None, 'transformation_add_MANUAL')
    
    def _initialized_behaviour_wait_for_action_megamodelling_18_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_18_guard(self, parameters):
        return self.expect_action(None, 'transformation_execute')
    
    def _initialized_behaviour_wait_for_action_megamodelling_19_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_19_guard(self, parameters):
        return self.expect_action(None, 'process_execute')
    
    def _initialized_behaviour_wait_for_action_megamodelling_20_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_20_guard(self, parameters):
        return self.expect_action(None, 'permission_modify')
    
    def _initialized_behaviour_wait_for_action_megamodelling_21_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_21_guard(self, parameters):
        return self.expect_action(None, 'permission_owner')
    
    def _initialized_behaviour_wait_for_action_megamodelling_22_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_22_guard(self, parameters):
        return self.expect_action(None, 'permission_group')
    
    def _initialized_behaviour_wait_for_action_megamodelling_23_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_23_guard(self, parameters):
        return self.expect_action(None, 'group_create')
    
    def _initialized_behaviour_wait_for_action_megamodelling_24_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_24_guard(self, parameters):
        return self.expect_action(None, 'group_delete')
    
    def _initialized_behaviour_wait_for_action_megamodelling_25_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_25_guard(self, parameters):
        return self.expect_action(None, 'group_owner_add')
    
    def _initialized_behaviour_wait_for_action_megamodelling_26_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_26_guard(self, parameters):
        return self.expect_action(None, 'group_owner_delete')
    
    def _initialized_behaviour_wait_for_action_megamodelling_27_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_27_guard(self, parameters):
        return self.expect_action(None, 'group_join')
    
    def _initialized_behaviour_wait_for_action_megamodelling_28_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_28_guard(self, parameters):
        return self.expect_action(None, 'group_kick')
    
    def _initialized_behaviour_wait_for_action_megamodelling_29_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_29_guard(self, parameters):
        return self.expect_action(None, 'group_list')
    
    def _initialized_behaviour_wait_for_action_megamodelling_30_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_30_guard(self, parameters):
        return self.expect_action(None, 'admin_promote')
    
    def _initialized_behaviour_wait_for_action_megamodelling_31_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_31_guard(self, parameters):
        return self.expect_action(None, 'admin_demote')
    
    def _initialized_behaviour_wait_for_action_megamodelling_32_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_32_guard(self, parameters):
        return self.expect_action(None, 'conformance_delete')
    
    def _initialized_behaviour_wait_for_action_megamodelling_33_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_33_guard(self, parameters):
        return self.expect_action(None, 'conformance_add')
    
    def _initialized_behaviour_wait_for_action_megamodelling_34_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_34_guard(self, parameters):
        return self.expect_action(None, 'folder_create')
    
    def _initialized_behaviour_wait_for_action_megamodelling_35_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_35_guard(self, parameters):
        return self.expect_action(None, 'model_types')
    
    def _initialized_behaviour_wait_for_action_megamodelling_36_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_megamodelling_36_guard(self, parameters):
        return self.expect_action(None, 'service_register')
    
    def _initialized_behaviour_wait_for_action_megamodelling_37_guard(self, parameters):
        return self.expect_action(None, ['element_list', 'element_list_nice', 'types', 'types_full', 'read_info', 'read_attrs', 'read_defined_attrs', 'instantiate', 'delete_element', 'attr_assign', 'attr_assign_code', 'attr_delete', 'read_outgoing', 'read_incoming', 'read_association_source', 'read_association_destination', 'connections_between', 'define_attribute', 'undefine_attribute', 'all_instances', 'attr_optional', 'attr_type', 'attr_name'])
    
    def _initialized_behaviour_wait_for_action_service_0_exec(self, parameters):
        import modelverse
        thrd = threading.Thread(target=self.service_function, args=[self.responses.pop(0)])
        thrd.daemon = True
        thrd.start()
    
    def _initialized_behaviour_wait_for_action_service_0_guard(self, parameters):
        return self.expect_response_partial('', pop=False)
    
    def _initialized_behaviour_wait_for_action_service_1_exec(self, parameters):
        self.load_action(None)
    
    def _initialized_behaviour_wait_for_action_service_1_guard(self, parameters):
        return self.expect_action(None, 'service_stop')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_manual_0_guard(self, parameters):
        return self.expect_action(self.context, 'exit')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_manual_1_guard(self, parameters):
        return self.expect_action(self.context, 'drop')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_manual_2_guard(self, parameters):
        return self.actions[self.context] and self.actions[self.context][0]['parameters'][0] != self.current_model
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_scripted_0_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, ['exit']))
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_scripted_0_guard(self, parameters):
        return self.expect_action(self.context, 'exit')
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_scripted_1_exec(self, parameters):
        self.raiseInternalEvent(Event("request", None, ['drop']))
    
    def _initialized_behaviour_wait_for_action_modelling_recognized_scripted_1_guard(self, parameters):
        return self.expect_action(self.context, 'drop')
    
    def _initialized_behaviour_going_manual_init_0_guard(self, parameters):
        return self.current_model in self.registered_metamodel
    
    def _initialized_behaviour_going_manual_init_1_guard(self, parameters):
        return self.current_model not in self.registered_metamodel
    
    def _initialized_behaviour_going_manual_search_0_exec(self, parameters):
        self.registered_metamodel[self.current_model] = set(self.split_response(self.responses.pop(0))).pop()
    
    def _initialized_behaviour_going_manual_search_0_guard(self, parameters):
        return self.expect_response_partial('Success: ')
    
    def _initialized_behaviour_going_manual_OK_0_guard(self, parameters):
        return self.expect_response('Model loaded, ready for commands!', pop=True)
    
    def _initialized_behaviour_going_manual_OK_1_exec(self, parameters):
        self.raiseInternalEvent(Event("exception", None, ['UnknownMetamodellingHierarchy', 'Conformance relation not found']))
        self.responses.pop(0)
        self.actions[None].pop(0)
    
    def _initialized_behaviour_going_manual_OK_1_guard(self, parameters):
        return self.expect_response_partial('No conformance relation can be found ', pop=False)
    
    def _initialized_behaviour_leaving_manual_0_guard(self, parameters):
        return self.expect_response('Success', pop=True)
    
    def _initialized_behaviour_leaving_manual_drop_0_guard(self, parameters):
        return self.expect_response('Success', pop=True)
    
    def _initialized_queue_queue_0_exec(self, parameters):
        action_name = parameters[0]
        ID = parameters[1]
        context_ID = parameters[2]
        parameters = parameters[3]
        self.actions[context_ID].append({"name": action_name, "ID": ID, "parameters": parameters})
    
    def _initialized_queue_queue_1_exec(self, parameters):
        parameters = parameters[0]
        self.big_step.outputEvent(Event("result", "action_out", [self.current_ID, parameters]))
        self.big_step.outputEventOM(Event("broad_cast", None, [self, Event("mv_result", None, [self.current_ID, parameters])]))
    
    def _initialized_queue_queue_2_exec(self, parameters):
        parameters = parameters[0]
        self.big_step.outputEvent(Event("data_output", "action_out", [parameters]))
        self.big_step.outputEventOM(Event("broad_cast", None, [self, Event("mv_data_output", None, [parameters])]))
    
    def _initialized_queue_queue_3_exec(self, parameters):
        ID = parameters[0]
        parameters = parameters[1]
        self.big_step.outputEvent(Event("exception", "action_out", [self.current_ID, ID, parameters]))
        self.big_step.outputEventOM(Event("broad_cast", None, [self, Event("mv_exception", None, [self.current_ID, ID, parameters])]))
    
    def _initialized_queue_queue_4_exec(self, parameters):
        self.big_step.outputEvent(Event("ready", "ready", []))
        self.big_step.outputEventOM(Event("broad_cast", None, [self, Event("mv_ready", None, [])]))
    
    def _initialized_queue_queue_5_exec(self, parameters):
        value = parameters[0]
        context_ID = parameters[1]
        self.inputs[context_ID].append({"name": "data_input", "parameters": value})
    
    def initializeStatechart(self):
        # enter default state
        self.default_targets = self.states["/init"].getEffectiveTargetStates()
        RuntimeClassBase.initializeStatechart(self)

class HTTPClient(RuntimeClassBase):
    def __init__(self, controller):
        RuntimeClassBase.__init__(self, controller)
        
        self.semantics.big_step_maximality = StatechartSemantics.TakeMany
        self.semantics.internal_event_lifeline = StatechartSemantics.Queue
        self.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep
        self.semantics.priority = StatechartSemantics.SourceParent
        self.semantics.concurrency = StatechartSemantics.Single
        
        # build Statechart structure
        self.build_statechart_structure()
        
        # call user defined constructor
        HTTPClient.user_defined_constructor(self)
    
    def user_defined_constructor(self):
        self.socket = None
        self.received_data = ""
        self.send_data = ""
        self.queue = []
        self.IDs = []
    
    def user_defined_destructor(self):
        pass
    
    
    # builds Statechart structure
    def build_statechart_structure(self):
        
        # state <root>
        self.states[""] = State(0, "", self)
        
        # state /init
        self.states["/init"] = State(1, "/init", self)
        self.states["/init"].setEnter(self._init_enter)
        
        # state /waiting
        self.states["/waiting"] = State(2, "/waiting", self)
        self.states["/waiting"].setEnter(self._waiting_enter)
        
        # state /connecting
        self.states["/connecting"] = State(3, "/connecting", self)
        self.states["/connecting"].setEnter(self._connecting_enter)
        self.states["/connecting"].setExit(self._connecting_exit)
        
        # state /connecting/connecting
        self.states["/connecting/connecting"] = State(4, "/connecting/connecting", self)
        self.states["/connecting/connecting"].setEnter(self._connecting_connecting_enter)
        
        # state /connecting/cooldown
        self.states["/connecting/cooldown"] = State(5, "/connecting/cooldown", self)
        self.states["/connecting/cooldown"].setEnter(self._connecting_cooldown_enter)
        self.states["/connecting/cooldown"].setExit(self._connecting_cooldown_exit)
        
        # state /connected
        self.states["/connected"] = ParallelState(6, "/connected", self)
        
        # state /connected/listening
        self.states["/connected/listening"] = State(7, "/connected/listening", self)
        
        # state /connected/listening/listen
        self.states["/connected/listening/listen"] = State(8, "/connected/listening/listen", self)
        self.states["/connected/listening/listen"].setEnter(self._connected_listening_listen_enter)
        
        # state /connected/listening/close
        self.states["/connected/listening/close"] = State(9, "/connected/listening/close", self)
        
        # state /connected/sending
        self.states["/connected/sending"] = State(10, "/connected/sending", self)
        
        # state /connected/sending/waiting_for_data
        self.states["/connected/sending/waiting_for_data"] = State(11, "/connected/sending/waiting_for_data", self)
        
        # state /connected/sending/transferring
        self.states["/connected/sending/transferring"] = State(12, "/connected/sending/transferring", self)
        
        # state /connected/queueing
        self.states["/connected/queueing"] = State(13, "/connected/queueing", self)
        
        # state /connected/queueing/queueing
        self.states["/connected/queueing/queueing"] = State(14, "/connected/queueing/queueing", self)
        self.states["/connected/queueing/queueing"].setEnter(self._connected_queueing_queueing_enter)
        
        # state /connected/parsing
        self.states["/connected/parsing"] = State(15, "/connected/parsing", self)
        
        # state /connected/parsing/wait_for_header
        self.states["/connected/parsing/wait_for_header"] = State(16, "/connected/parsing/wait_for_header", self)
        
        # state /connected/parsing/wait_for_payload
        self.states["/connected/parsing/wait_for_payload"] = State(17, "/connected/parsing/wait_for_payload", self)
        
        # add children
        self.states[""].addChild(self.states["/init"])
        self.states[""].addChild(self.states["/waiting"])
        self.states[""].addChild(self.states["/connecting"])
        self.states[""].addChild(self.states["/connected"])
        self.states["/connecting"].addChild(self.states["/connecting/connecting"])
        self.states["/connecting"].addChild(self.states["/connecting/cooldown"])
        self.states["/connected"].addChild(self.states["/connected/listening"])
        self.states["/connected"].addChild(self.states["/connected/sending"])
        self.states["/connected"].addChild(self.states["/connected/queueing"])
        self.states["/connected"].addChild(self.states["/connected/parsing"])
        self.states["/connected/listening"].addChild(self.states["/connected/listening/listen"])
        self.states["/connected/listening"].addChild(self.states["/connected/listening/close"])
        self.states["/connected/sending"].addChild(self.states["/connected/sending/waiting_for_data"])
        self.states["/connected/sending"].addChild(self.states["/connected/sending/transferring"])
        self.states["/connected/queueing"].addChild(self.states["/connected/queueing/queueing"])
        self.states["/connected/parsing"].addChild(self.states["/connected/parsing/wait_for_header"])
        self.states["/connected/parsing"].addChild(self.states["/connected/parsing/wait_for_payload"])
        self.states[""].fixTree()
        self.states[""].default_state = self.states["/init"]
        self.states["/connecting"].default_state = self.states["/connecting/connecting"]
        self.states["/connected/listening"].default_state = self.states["/connected/listening/listen"]
        self.states["/connected/sending"].default_state = self.states["/connected/sending/waiting_for_data"]
        self.states["/connected/queueing"].default_state = self.states["/connected/queueing/queueing"]
        self.states["/connected/parsing"].default_state = self.states["/connected/parsing/wait_for_header"]
        
        # transition /init
        _init_0 = Transition(self, self.states["/init"], [self.states["/waiting"]])
        _init_0.setAction(self._init_0_exec)
        _init_0.setTrigger(Event("created_socket", "socket_in"))
        _init_0.setGuard(self._init_0_guard)
        self.states["/init"].addTransition(_init_0)
        
        # transition /waiting
        _waiting_0 = Transition(self, self.states["/waiting"], [self.states["/connecting"]])
        _waiting_0.setAction(self._waiting_0_exec)
        _waiting_0.setTrigger(Event("connect", None))
        self.states["/waiting"].addTransition(_waiting_0)
        
        # transition /connecting/connecting
        _connecting_connecting_0 = Transition(self, self.states["/connecting/connecting"], [self.states["/connecting/cooldown"]])
        _connecting_connecting_0.setTrigger(Event("error_socket", "socket_in"))
        self.states["/connecting/connecting"].addTransition(_connecting_connecting_0)
        _connecting_connecting_1 = Transition(self, self.states["/connecting/connecting"], [self.states["/connected"]])
        _connecting_connecting_1.setAction(self._connecting_connecting_1_exec)
        _connecting_connecting_1.setTrigger(Event("connected_socket", "socket_in"))
        _connecting_connecting_1.setGuard(self._connecting_connecting_1_guard)
        self.states["/connecting/connecting"].addTransition(_connecting_connecting_1)
        
        # transition /connecting/cooldown
        _connecting_cooldown_0 = Transition(self, self.states["/connecting/cooldown"], [self.states["/connecting/connecting"]])
        _connecting_cooldown_0.setTrigger(Event("_1after"))
        self.states["/connecting/cooldown"].addTransition(_connecting_cooldown_0)
        
        # transition /connected/listening/listen
        _connected_listening_listen_0 = Transition(self, self.states["/connected/listening/listen"], [self.states["/connected/listening/listen"]])
        _connected_listening_listen_0.setAction(self._connected_listening_listen_0_exec)
        _connected_listening_listen_0.setTrigger(Event("received_socket", "socket_in"))
        _connected_listening_listen_0.setGuard(self._connected_listening_listen_0_guard)
        self.states["/connected/listening/listen"].addTransition(_connected_listening_listen_0)
        _connected_listening_listen_1 = Transition(self, self.states["/connected/listening/listen"], [self.states["/connected/listening/close"]])
        _connected_listening_listen_1.setTrigger(Event("received_socket", "socket_in"))
        _connected_listening_listen_1.setGuard(self._connected_listening_listen_1_guard)
        self.states["/connected/listening/listen"].addTransition(_connected_listening_listen_1)
        
        # transition /connected/sending/waiting_for_data
        _connected_sending_waiting_for_data_0 = Transition(self, self.states["/connected/sending/waiting_for_data"], [self.states["/connected/sending/transferring"]])
        _connected_sending_waiting_for_data_0.setAction(self._connected_sending_waiting_for_data_0_exec)
        _connected_sending_waiting_for_data_0.setTrigger(None)
        _connected_sending_waiting_for_data_0.setGuard(self._connected_sending_waiting_for_data_0_guard)
        self.states["/connected/sending/waiting_for_data"].addTransition(_connected_sending_waiting_for_data_0)
        
        # transition /connected/sending/transferring
        _connected_sending_transferring_0 = Transition(self, self.states["/connected/sending/transferring"], [self.states["/connected/sending/waiting_for_data"]])
        _connected_sending_transferring_0.setAction(self._connected_sending_transferring_0_exec)
        _connected_sending_transferring_0.setTrigger(Event("sent_socket", "socket_in"))
        _connected_sending_transferring_0.setGuard(self._connected_sending_transferring_0_guard)
        self.states["/connected/sending/transferring"].addTransition(_connected_sending_transferring_0)
        
        # transition /connected/queueing/queueing
        _connected_queueing_queueing_0 = Transition(self, self.states["/connected/queueing/queueing"], [self.states["/connected/queueing/queueing"]])
        _connected_queueing_queueing_0.setAction(self._connected_queueing_queueing_0_exec)
        _connected_queueing_queueing_0.setTrigger(Event("HTTP_input", None))
        self.states["/connected/queueing/queueing"].addTransition(_connected_queueing_queueing_0)
        
        # transition /connected/parsing/wait_for_header
        _connected_parsing_wait_for_header_0 = Transition(self, self.states["/connected/parsing/wait_for_header"], [self.states["/connected/parsing/wait_for_payload"]])
        _connected_parsing_wait_for_header_0.setAction(self._connected_parsing_wait_for_header_0_exec)
        _connected_parsing_wait_for_header_0.setTrigger(None)
        _connected_parsing_wait_for_header_0.setGuard(self._connected_parsing_wait_for_header_0_guard)
        self.states["/connected/parsing/wait_for_header"].addTransition(_connected_parsing_wait_for_header_0)
        
        # transition /connected/parsing/wait_for_payload
        _connected_parsing_wait_for_payload_0 = Transition(self, self.states["/connected/parsing/wait_for_payload"], [self.states["/connected/parsing/wait_for_header"]])
        _connected_parsing_wait_for_payload_0.setAction(self._connected_parsing_wait_for_payload_0_exec)
        _connected_parsing_wait_for_payload_0.setTrigger(None)
        _connected_parsing_wait_for_payload_0.setGuard(self._connected_parsing_wait_for_payload_0_guard)
        self.states["/connected/parsing/wait_for_payload"].addTransition(_connected_parsing_wait_for_payload_0)
        _connected_parsing_wait_for_payload_1 = Transition(self, self.states["/connected/parsing/wait_for_payload"], [self.states["/connected/parsing/wait_for_header"]])
        _connected_parsing_wait_for_payload_1.setAction(self._connected_parsing_wait_for_payload_1_exec)
        _connected_parsing_wait_for_payload_1.setTrigger(None)
        _connected_parsing_wait_for_payload_1.setGuard(self._connected_parsing_wait_for_payload_1_guard)
        self.states["/connected/parsing/wait_for_payload"].addTransition(_connected_parsing_wait_for_payload_1)
        
        # transition /connecting
        _connecting_0 = Transition(self, self.states["/connecting"], [self.states["/waiting"]])
        _connecting_0.setAction(self._connecting_0_exec)
        _connecting_0.setTrigger(Event("_0after"))
        self.states["/connecting"].addTransition(_connecting_0)
    
    def _connecting_enter(self):
        self.addTimer(0, self.timeout)
    
    def _connecting_exit(self):
        self.removeTimer(0)
    
    def _init_enter(self):
        self.ID = str(uuid.uuid4())
        self.big_step.outputEvent(Event("create_socket", "socket_out", [self.ID]))
    
    def _waiting_enter(self):
        self.big_step.outputEventOM(Event("broad_cast", None, [self, Event("http_client_initialized", None, [])]))
    
    def _connecting_connecting_enter(self):
        self.big_step.outputEvent(Event("connect_socket", "socket_out", [self.socket, self.address]))
    
    def _connecting_cooldown_enter(self):
        self.addTimer(1, 0.1)
    
    def _connecting_cooldown_exit(self):
        self.removeTimer(1)
    
    def _connected_listening_listen_enter(self):
        self.big_step.outputEvent(Event("recv_socket", "socket_out", [self.socket]))
    
    def _connected_queueing_queueing_enter(self):
        pass
    
    def _connecting_0_exec(self, parameters):
        self.big_step.outputEventOM(Event("broad_cast", None, [self, Event("http_client_timeout", None, [])]))
    
    def _init_0_exec(self, parameters):
        socket = parameters[0]
        ID = parameters[1]
        self.socket = socket
    
    def _init_0_guard(self, parameters):
        socket = parameters[0]
        ID = parameters[1]
        return self.ID == ID
    
    def _waiting_0_exec(self, parameters):
        address = parameters[0]
        timeout = parameters[1]
        self.address = address
        self.timeout = timeout
    
    def _connecting_connecting_1_exec(self, parameters):
        socket = parameters[0]
        self.big_step.outputEventOM(Event("broad_cast", None, [self, Event("http_client_ready", None, [])]))
    
    def _connecting_connecting_1_guard(self, parameters):
        socket = parameters[0]
        return self.socket == socket
    
    def _connected_listening_listen_0_exec(self, parameters):
        socket = parameters[0]
        data = parameters[1]
        self.received_data += data
    
    def _connected_listening_listen_0_guard(self, parameters):
        socket = parameters[0]
        data = parameters[1]
        return (self.socket == socket) and (len(data) > 0)
    
    def _connected_listening_listen_1_guard(self, parameters):
        socket = parameters[0]
        data = parameters[1]
        return (self.socket == socket) and (len(data) == 0)
    
    def _connected_sending_waiting_for_data_0_exec(self, parameters):
        self.big_step.outputEvent(Event("send_socket", "socket_out", [self.socket, self.send_data]))
    
    def _connected_sending_waiting_for_data_0_guard(self, parameters):
        return len(self.send_data) > 0
    
    def _connected_sending_transferring_0_exec(self, parameters):
        socket = parameters[0]
        sent_bytes = parameters[1]
        self.send_data = self.send_data[sent_bytes:]
    
    def _connected_sending_transferring_0_guard(self, parameters):
        socket = parameters[0]
        sent_bytes = parameters[1]
        return self.socket == socket
    
    def _connected_queueing_queueing_0_exec(self, parameters):
        data = parameters[0]
        ID = parameters[1]
        self.send_data += "POST / HTTP/1.0\r\n"
        self.send_data += "Content-Length: %i\r\n" % len(str(data))
        self.send_data += "\r\n"
        self.send_data += data
        self.IDs.append(ID)
    
    def _connected_parsing_wait_for_header_0_exec(self, parameters):
        header, self.received_data = self.received_data.split("\r\n\r\n", 1)
        header = header.lower()
        if "content-length" in header:
            _, after = header.split("content-length:", 1)
            after, _ = after.split("\r\n", 1)
            after = after.strip()
            self.length = int(after)
        else:
            self.length = float('inf')
    
    def _connected_parsing_wait_for_header_0_guard(self, parameters):
        return '\r\n\r\n' in self.received_data
    
    def _connected_parsing_wait_for_payload_0_exec(self, parameters):
        data = self.received_data[:self.length]
        self.received_data = self.received_data[self.length:]
        self.big_step.outputEventOM(Event("broad_cast", None, [self, Event("HTTP_output", None, [data, self.IDs.pop(0)])]))
    
    def _connected_parsing_wait_for_payload_0_guard(self, parameters):
        return len(self.received_data) >= self.length and self.IDs[0] is not None
    
    def _connected_parsing_wait_for_payload_1_exec(self, parameters):
        # Drop data
        self.received_data = self.received_data[self.length:]
        self.IDs.pop(0)
    
    def _connected_parsing_wait_for_payload_1_guard(self, parameters):
        return len(self.received_data) >= self.length and self.IDs[0] is None
    
    def initializeStatechart(self):
        # enter default state
        self.default_targets = self.states["/init"].getEffectiveTargetStates()
        RuntimeClassBase.initializeStatechart(self)

class ObjectManager(ObjectManagerBase):
    def __init__(self, controller):
        ObjectManagerBase.__init__(self, controller)
    
    def instantiate(self, class_name, construct_params):
        if class_name == "Modelverse":
            instance = Modelverse(self.controller)
            instance.associations = {}
            instance.associations["http_client"] = Association("HTTPClient", 2, 2)
        elif class_name == "HTTPClient":
            instance = HTTPClient(self.controller)
            instance.associations = {}
        else:
            raise Exception("Cannot instantiate class " + class_name)
        return instance

class Controller(ThreadsControllerBase):
    def __init__(self, keep_running = None, behind_schedule_callback = None):
        if keep_running == None: keep_running = True
        if behind_schedule_callback == None: behind_schedule_callback = None
        ThreadsControllerBase.__init__(self, ObjectManager(self), keep_running, behind_schedule_callback)
        self.addInputPort("socket_in")
        self.addInputPort("action_in")
        self.addOutputPort("socket_out")
        self.addOutputPort("action_out")
        self.addOutputPort("ready")
        self.object_manager.createInstance("Modelverse", [])